//  
//  scriptFunctions.cs
//  
//  Author:
//       Robert BRACCAGNI alias Gai-Luron <lfsgailuron@free.fr>
// 
//  Copyright (c) 2010 Gai-Luron
// 
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
// 
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
// 
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.

using System;
using System.Collections;
using System.Text.RegularExpressions;
using UTILS;
using System.Threading;
using System.IO;
using System.Text;

namespace LFSLapper
{
    partial class LFSClient
    {
        public String Lyt = "";
        class LOP
		{
			public string userName = "";
			public string nickName = "";
			public LOP(string pUN, string pNN)
			{
				userName = pUN;
				nickName = pNN;
			}
		}
		public class sortByUName : IComparer
		{
			int IComparer.Compare(object a, object b)
			{
				if (string.Compare((a as LOP).userName, (b as LOP).userName) > 0)
					return 1;
				else if (string.Compare((a as LOP).userName, (b as LOP).userName) < 0)
					return -1;
				else
					return 0;
			}
		}
		public class sortByNName : IComparer
		{
			int IComparer.Compare(object a, object b)
			{
				if (string.Compare((a as LOP).nickName, (b as LOP).nickName) > 0)
					return 1;
				else if (string.Compare((a as LOP).nickName, (b as LOP).nickName) < 0)
					return -1;
				else
					return 0;
			}
		}

        public void initScriptFunction()
        {
            //            newCfg.CurrApp.addCallBackFunction("test", test);
            newCfg.CurrApp.registerCallBackFunction("getplayerinfo", getplayerinfo);
            newCfg.CurrApp.registerCallBackFunction("openprivbutton", openprivbutton);
            newCfg.CurrApp.registerCallBackFunction("closeprivbutton", closeprivbutton);
            newCfg.CurrApp.registerCallBackFunction("openbutton", openbutton);
            newCfg.CurrApp.registerCallBackFunction("closebutton", closebutton);
            newCfg.CurrApp.registerCallBackFunction("setracegrid", setracegrid);
            newCfg.CurrApp.registerCallBackFunction("requestreo", requestreo);
            newCfg.CurrApp.registerCallBackFunction("getlistofplayers", getlistofplayers);
            newCfg.CurrApp.registerCallBackFunction("getlappervar", getlappervar);
            newCfg.CurrApp.registerCallBackFunction("getconfigvar", getconfigvar);
            newCfg.CurrApp.registerCallBackFunction("setconfigvar", setconfigvar);
            newCfg.CurrApp.registerCallBackFunction("numtomsh", numtomsh);
            newCfg.CurrApp.registerCallBackFunction("numtoms", numtoms);
            newCfg.CurrApp.registerCallBackFunction("mshtonum", mshtonum);
            newCfg.CurrApp.registerCallBackFunction("tokph", tokph);
            newCfg.CurrApp.registerCallBackFunction("tomph", tomph);
            newCfg.CurrApp.registerCallBackFunction("toplayerunit", toplayerunit);
            newCfg.CurrApp.registerCallBackFunction("langtranslate", langtranslate);
            newCfg.CurrApp.registerCallBackFunction("langengine", langengine);
            newCfg.CurrApp.registerCallBackFunction("forcerotation", forcerotation);
            newCfg.CurrApp.registerCallBackFunction("termlapper", termlapper);
            newCfg.CurrApp.registerCallBackFunction("groupcmdlfs", groupcmdlfs);
            newCfg.CurrApp.registerCallBackFunction("cmdlfs", cmdlfs);
            newCfg.CurrApp.registerCallBackFunction("setlicense", setlicense);
            //Set/get Player Vars
            newCfg.CurrApp.registerCallBackFunction("setcurrentplayervar", setcurrentplayervar);
            newCfg.CurrApp.registerCallBackFunction("getcurrentplayervar", getcurrentplayervar);
            newCfg.CurrApp.registerCallBackFunction("setplayervar", setplayervar);
            newCfg.CurrApp.registerCallBackFunction("getplayervar", getplayervar);
            newCfg.CurrApp.registerCallBackFunction("getplayervarbyucid", getplayervarbyucid);
            newCfg.CurrApp.registerCallBackFunction("getplayervarbyplid", getplayervarbyplid);

            newCfg.CurrApp.registerCallBackFunction("privmsg", privmsg);
            newCfg.CurrApp.registerCallBackFunction("globalmsg", globalmsg);
            newCfg.CurrApp.registerCallBackFunction("cleanspb", cleanspb);
            newCfg.CurrApp.registerCallBackFunction("showspb", showspb);
            newCfg.CurrApp.registerCallBackFunction("showhand", showhand);
            newCfg.CurrApp.registerCallBackFunction("lapperversion", lapperversion);
            newCfg.CurrApp.registerCallBackFunction("stats", stats);
            newCfg.CurrApp.registerCallBackFunction("dstats", dstats);
            newCfg.CurrApp.registerCallBackFunction("statsqual", statsqual);
            newCfg.CurrApp.registerCallBackFunction("dstatsqual", dstatsqual);

            newCfg.CurrApp.registerCallBackFunction("currentplayerlfsworldpb", currentplayerlfsworldpb);
            newCfg.CurrApp.registerCallBackFunction("currentplayerlfsworldpbfrom", currentplayerlfsworldpbfrom);

            newCfg.CurrApp.registerCallBackFunction("getlisttop", getlisttop);
            newCfg.CurrApp.registerCallBackFunction("getlisttopdrift", getlisttopdrift);
            newCfg.CurrApp.registerCallBackFunction("getlisttopuser", getlisttopuser);

            newCfg.CurrApp.registerCallBackFunction("privrcm", privrcm);
            newCfg.CurrApp.registerCallBackFunction("textprivbutton", textprivbutton);
            newCfg.CurrApp.registerCallBackFunction("textprivbuttonall", textprivbuttonall);
            newCfg.CurrApp.registerCallBackFunction("openprivtextbutton", openprivtextbutton);
            newCfg.CurrApp.registerCallBackFunction("opentextbutton", opentextbutton);
            newCfg.CurrApp.registerCallBackFunction("myconfig", myconfig);

            newCfg.CurrApp.registerCallBackFunction("openglobalbutton", openglobalbutton);
            newCfg.CurrApp.registerCallBackFunction("globalrcm", globalrcm);
            newCfg.CurrApp.registerCallBackFunction("closeglobalbutton", closeglobalbutton);
            newCfg.CurrApp.registerCallBackFunction("http", http);
            newCfg.CurrApp.registerCallBackFunction("moveusertogroup", moveusertogroup);
            newCfg.CurrApp.registerCallBackFunction("getlistofusersgroup", getlistofusersgroup);
            newCfg.CurrApp.registerCallBackFunction("usergroupfromfile", usergroupfromfile);
            newCfg.CurrApp.registerCallBackFunction("usergrouptofile", usergrouptofile);
            newCfg.CurrApp.registerCallBackFunction("removeuserfromgroup", removeuserfromgroup);
            newCfg.CurrApp.registerCallBackFunction("cleargroup", cleargroup);
            newCfg.CurrApp.registerCallBackFunction("userisadmin", userisadmin);
            newCfg.CurrApp.registerCallBackFunction("userisserveradmin", userisserveradmin);
            newCfg.CurrApp.registerCallBackFunction("useringroup", useringroup);
            newCfg.CurrApp.registerCallBackFunction("getusergrippb", getusergrippb);
            newCfg.CurrApp.registerCallBackFunction("getuserdriftpb", getuserdriftpb);

            //Get/Set/delete Stored (user) values.
            newCfg.CurrApp.registerCallBackFunction("setstoredvalue", setstoredvalue);
            newCfg.CurrApp.registerCallBackFunction("getstoredvalue", getstoredvalue);
            newCfg.CurrApp.registerCallBackFunction("getstorednum", getstorednum);
            newCfg.CurrApp.registerCallBackFunction("deletestoredvalue", deletestoredvalue);
            newCfg.CurrApp.registerCallBackFunction("setuserstoredvalue", setuserstoredvalue);
            newCfg.CurrApp.registerCallBackFunction("setuserstorednum", setuserstoredvalue);
            newCfg.CurrApp.registerCallBackFunction("getuserstoredvalue", getuserstoredvalue);
            newCfg.CurrApp.registerCallBackFunction("getuserstorednum", getuserstorednum);
            newCfg.CurrApp.registerCallBackFunction("deleteuserstoredvalue", deleteuserstoredvalue);

            //DelayedCommand actions
            newCfg.CurrApp.registerCallBackFunction("removedelayedcommand", removedelayedcommand);
            newCfg.CurrApp.registerCallBackFunction("delayedcommand", delayedcommand);
            newCfg.CurrApp.registerCallBackFunction("removeprivdelayedcommand", removeprivdelayedcommand);
            newCfg.CurrApp.registerCallBackFunction("privdelayedcommand", privdelayedcommand);
            newCfg.CurrApp.registerCallBackFunction("removehostdelayedcommand", removehostdelayedcommand);
            newCfg.CurrApp.registerCallBackFunction("hostdelayedcommand", hostdelayedcommand);

            newCfg.CurrApp.registerCallBackFunction("getlongtrackname", getlongtrackname);
            newCfg.CurrApp.registerCallBackFunction("getlengthtrack", getlengthtrack);
            newCfg.CurrApp.registerCallBackFunction("getgrouptrack", getgrouptrack);
            newCfg.CurrApp.registerCallBackFunction("getexttrack", getexttrack);
            //Schedule Actions
            newCfg.CurrApp.registerCallBackFunction("registerscheduleaction", registerscheduleaction);
            newCfg.CurrApp.registerCallBackFunction("removescheduleaction", removescheduleaction);
            //Node/Zone Actions
            newCfg.CurrApp.registerCallBackFunction("registernodeaction", registernodeaction);
            newCfg.CurrApp.registerCallBackFunction("removenodeaction", removenodeaction);
            newCfg.CurrApp.registerCallBackFunction("registerzoneaction", registerzoneaction);
            newCfg.CurrApp.registerCallBackFunction("removezoneaction", removezoneaction);

            newCfg.CurrApp.registerCallBackFunction("reload", reload);
            newCfg.CurrApp.registerCallBackFunction("crash", crash);
            newCfg.CurrApp.registerCallBackFunction("getlistoflang", getlistoflang);
            newCfg.CurrApp.registerCallBackFunction("getlistofplayerbuttons", getlistofplayerbuttons);
            newCfg.CurrApp.registerCallBackFunction("striplfscolor", striplfscolor);
            newCfg.CurrApp.registerCallBackFunction("getwr", getwr);
            newCfg.CurrApp.registerCallBackFunction("getlayoutinfo", getlayoutinfo);
            newCfg.CurrApp.registerCallBackFunction("startlightcontrol", startlightcontrol);
            newCfg.CurrApp.registerCallBackFunction("joinrequest", joinrequest);
            //Set allowed cars to the server or player
            newCfg.CurrApp.registerCallBackFunction("allowedplayercars", allowedplayercars);
            newCfg.CurrApp.registerCallBackFunction("setallowedcars", setallowedcars);

            newCfg.CurrApp.registerCallBackFunction("trackuserdistance", trackuserdistance);

            //axm insimpacket
            newCfg.CurrApp.registerCallBackFunction("addobject", addobject);
            newCfg.CurrApp.registerCallBackFunction("removeobject", removeobject);
            newCfg.CurrApp.registerCallBackFunction("objectinfo", objectinfo);
            newCfg.CurrApp.registerCallBackFunction("layoutinfo", layoutinfo); //Info about the layout TINY_AXI
            newCfg.CurrApp.registerCallBackFunction("connectioninfo", connectinfo);//Get extra player (EACH PLAYER IN THE SERVER) info for the host NCI insimpacket

            //Deleting records from database
            newCfg.CurrApp.registerCallBackFunction("deletedriftrecords", deletedriftrecords); //Delete driftrecords from current track from database
            newCfg.CurrApp.registerCallBackFunction("deletelaptimerecords", deletelaptimerecords); //Delete laptime records from current track from database

            //Streetcode Yisc[NL]
            newCfg.CurrApp.registerCallBackFunction("registerstreetaction", registerstreetaction);
            newCfg.CurrApp.registerCallBackFunction("removestreetaction", removestreetaction);

            //Retreive list of layouts from server
            newCfg.CurrApp.registerCallBackFunction("getlistoflayouts", getlistoflayouts);
            
            //Create/Read/Edit/Delete Files
            newCfg.CurrApp.registerCallBackFunction("createfile", createfile);
            newCfg.CurrApp.registerCallBackFunction("readfile", readfile);
            newCfg.CurrApp.registerCallBackFunction("deletefile", deletefile);
            newCfg.CurrApp.registerCallBackFunction("editfile", editfile);
            
        }
        #region Create/Read/edit/Delete textfiles
        public void createfile(GLScript.unionVal val, ArrayList args)
        {
            infoPlayer currInfoPlayer = newCfg.getCurrInfoPlayer();
            string ident = val.nameFunction;

            string FileName = args[0].ToString();
            string Folder = args[1].ToString();
            string FileExistTodo = args[2].ToString();

            if (((FileName != "") && (Folder != "") && (FileExistTodo != "")) && (args.Count == 3))
            {
                Thread CreateFileThread = new Thread(() => CreateFile(val, currInfoPlayer, ident, FileName, Folder, FileExistTodo));
                CreateFileThread.Start();
            }
            else
                throw new GLScript.GLApp.GLScriptException("ERROR on Function: '" + ident + "', incorrect number of parameters or parameters are wrong");

        }
        public void readfile(GLScript.unionVal val, ArrayList args)
        {
            infoPlayer currInfoPlayer = newCfg.getCurrInfoPlayer();
            string ident = val.nameFunction;

            string FileName = args[0].ToString();
            string Folder = args[1].ToString();
            string Extension = args[2].ToString();
            string FileCreationDate = "";
            string FileModificationDate = "";
            string FileSize = "";
            string Path = "";

            if (((FileName != "") && (Folder != "") && (Extension != "")) && (args.Count >= 3))
            {
                Path = @"" + Folder + "\\" + FileName + "" + Extension;

                ArrayList LinesofFile = new ArrayList();

                //Get lines of file.
                try
                {
                    int counter = 0;
                    string Line;


                    FileInfo File = new FileInfo(Path);
                    if (File.Exists)
                    {
                        //get info from file like Creationtime and modificationtime
                        FileCreationDate = File.CreationTime.ToString();
                        FileModificationDate = File.LastWriteTime.ToString();
                        FileSize = string.Format("{0}", File.Length);

                        System.IO.StreamReader readfile = new System.IO.StreamReader(Path);
                        //when line isnt empty
                        while ((Line = readfile.ReadLine()) != null)
                        {
                            //Add each line to array.
                            LinesofFile.Add(Line);
                            counter++;
                        }
                        //close file after reading it
                        readfile.Close();


                        //Set vars of each line from array
                        string Numberoflines = (LinesofFile.Count).ToString(); //Ignore first line of array

                        //Set variables for GLScript
                        val.typVal = GLScript.typVal.setOfVar;
                        val.setVars = new GLScript.SetOfVars();

                        //Set Number of Layout Var
                        val.setVars.Set(utils.quote("NumberOfLines"), new GLScript.unionVal(0, "\"" + Numberoflines + "\"", GLScript.typVal.str));
                        val.setVars.Set(utils.quote("TimeOfModification"), new GLScript.unionVal(0, "\"" + FileModificationDate + "\"", GLScript.typVal.str));
                        val.setVars.Set(utils.quote("TimeOfCreation"), new GLScript.unionVal(0, "\"" + FileCreationDate + "\"", GLScript.typVal.str));
                        val.setVars.Set(utils.quote("FileSize"), new GLScript.unionVal(0, "\"" + FileSize + "\"", GLScript.typVal.str));

                        for (int i = 0; i < LinesofFile.Count; i++)
                        {
                            string GetLineFromArray = LinesofFile[i] as string;
                            val.setVars.Set(i.ToString() + "," + utils.quote("LineNumber"), new GLScript.unionVal(0, "\"" + i + "\"", GLScript.typVal.str));
                            val.setVars.Set(i.ToString() + "," + utils.quote("Line"), new GLScript.unionVal(0, "\"" + GetLineFromArray + "\"", GLScript.typVal.str));
                        }
                    }
                }
                catch
                {

                }
            }
            else
                throw new GLScript.GLApp.GLScriptException("ERROR on Function: '" + ident + "', incorrect number of parameters or parameters are wrong");

        }

        public void deletefile(GLScript.unionVal val, ArrayList args)
        {
            infoPlayer currInfoPlayer = newCfg.getCurrInfoPlayer();
            string ident = val.nameFunction;

            string FileName = args[0].ToString();
            string Folder = args[1].ToString();
            string CopyFolder = args[2].ToString();
            string Extension = args[3].ToString();

            if (((FileName != "") && (Folder != "") && (Extension != "")) && (args.Count >= 3))
            {
                Thread DeleteFileThread = new Thread(() => DeleteFile(val, currInfoPlayer, ident, FileName, Folder, CopyFolder, Extension));
                DeleteFileThread.Start();
            }
            else
                throw new GLScript.GLApp.GLScriptException("ERROR on Function: '" + ident + "', incorrect number of parameters or parameters are wrong");  
        }

        public void editfile(GLScript.unionVal val, ArrayList args)
        {
            infoPlayer currInfoPlayer = newCfg.getCurrInfoPlayer();
            string ident = val.nameFunction;

            string FileName = args[0].ToString();
            string Folder = args[1].ToString();
            string Text = args[2].ToString();
            string LineToEdit = args[3].ToString();
            string Extension = args[4].ToString();

            if ((FileName != "") && (Folder != "") && (LineToEdit != "") && (Extension != ""))
            {
                Thread EditFileThread = new Thread(() => EditFile(val, currInfoPlayer, ident, FileName, Folder, Text, LineToEdit, Extension));
                EditFileThread.Start();
            }
            else
                throw new GLScript.GLApp.GLScriptException("ERROR on Function: '" + ident + "', incorrect number of parameters or parameters are wrong");
        }
        #endregion

        #region Delete stored values
        public void deleteuserstoredvalue(GLScript.unionVal val, ArrayList args)
        {
            infoPlayer currInfoPlayer = newCfg.getCurrInfoPlayer();
            string ident = val.nameFunction;

           try
            {
                string username = args[0].ToString();
                string userstoredvalue = args[1].ToString();

                if (((username != "") || (username != "-")) && ((userstoredvalue != "") || (userstoredvalue != "-")) || (args.Count == 2))
                {
                    testArgs(ident, "SS", args);
                    //                                 Username  userstoredvalue
                    storedSqlDbs.deletestoredvalueuser(username, userstoredvalue);
                }
                else
                {
                    throw new GLScript.GLApp.GLScriptException("ERROR on Function: '" + ident + "', Incorrect number of parameters or parameters are wrong");
                }
            }
            catch
            {
                throw new GLScript.GLApp.GLScriptException("ERROR on Function: '" + ident + "', ncorrect number of parameters or parameters are wrong");
            }
        }

        public void deletestoredvalue(GLScript.unionVal val, ArrayList args)
        {
            infoPlayer currInfoPlayer = newCfg.getCurrInfoPlayer();
            string ident = val.nameFunction;

            try
            {

                string storedvalue = args[0].ToString();

                if ((storedvalue != "") && (args.Count == 1))
                {
                    testArgs(ident, "S", args);
                    //                             StoredValue
                    storedSqlDbs.deletestoredvalue(storedvalue);
                }
                else
                {
                    throw new GLScript.GLApp.GLScriptException("ERROR on Function: '" + ident + "' Incorrect number of parameters or parameters are wrong");
                }
            }
            catch
            {
                throw new GLScript.GLApp.GLScriptException("ERROR on Function: '" + ident + "' Incorrect number of parameters or parameters are wrong");
            }
        }
        #endregion

        public void getlistoflayouts(GLScript.unionVal val, ArrayList args)
        {
            infoPlayer currInfoPlayer = newCfg.getCurrInfoPlayer();
            string ident = val.nameFunction;
            string Sort = args[1].ToString();
            string SortType = args[2].ToString();
            string Filter = args[0].ToString();
            String LayoutFolder = newCfg.varsLapper.LayoutFolder;

            string LayoutName = "";
            string DateModified = "";
            string DateCreated = "";

            try
            {
                //Checking layoutfolder
                if (LayoutFolder == "")
                {
                    SendMsgToConnection(currInfoPlayer.UCID, "^1ERROR: ^7Layoutfolder not defined");
                    SendMsgToConnection(currInfoPlayer.UCID, "^7Please contact the administrator");
                }
                else if (!Directory.Exists(LayoutFolder))
                {
                    SendMsgToConnection(currInfoPlayer.UCID, "^1ERROR: ^7Layoutfolder not found!");
                    SendMsgToConnection(currInfoPlayer.UCID, "^7Please contact the administrator");
                }
                else
                {
                    //Layoutfolder found
                    string[] files = Directory.GetFiles(LayoutFolder, "*.lyt");

                    if ((Sort != "") && (SortType != "") && (args.Count == 3))
                    {
                        ArrayList LayoutList = GetListOfLayouts(Filter, Sort, SortType, currState.ShortTrackName, LayoutFolder);

                        string NumberofLayouts = (LayoutList.Count-1).ToString(); //Ignore first line of array

                        //Set variables for GLScript
                        val.typVal = GLScript.typVal.setOfVar;
                        val.setVars = new GLScript.SetOfVars();

                        //Set Number of Layout Var
                        val.setVars.Set(utils.quote("NumberOfLayouts"), new GLScript.unionVal(0, "\"" + NumberofLayouts + "\"", GLScript.typVal.str));

                        for (int i = 1; i < LayoutList.Count; i++)
                        {
                            string Layoutinfo = LayoutList[i] as string;
                            string[] SplittedLayoutInfo = Layoutinfo.Split(',');

                                LayoutName = SplittedLayoutInfo[0];
                                DateModified = SplittedLayoutInfo[1];
                                DateCreated = SplittedLayoutInfo[2];
                           
                            val.setVars.Set(i.ToString() + "," + utils.quote("LayoutNumber"), new GLScript.unionVal(0, "\"" + i + "\"", GLScript.typVal.str));
                            val.setVars.Set(i.ToString() + "," + utils.quote("LayoutName"), new GLScript.unionVal(0, "\"" + LayoutName + "\"", GLScript.typVal.str));
                            val.setVars.Set(i.ToString() + "," + utils.quote("DateCreated"), new GLScript.unionVal(0, "\"" + DateModified + "\"", GLScript.typVal.str));
                            val.setVars.Set(i.ToString() + "," + utils.quote("DateModified"), new GLScript.unionVal(0, "\"" + DateCreated + "\"", GLScript.typVal.str));
                        }
                    }
                    else
                    {
                        throw new GLScript.GLApp.GLScriptException("ERROR on Function: '" + ident + "' Incorrect number of parameters or parameters are wrong");
                    }
                }
            }
            catch
            {
                SendMsgToConnection(currInfoPlayer.UCID,"^1Error: ^7Cannot retreive info from layoutfolder.");
                SendMsgToConnection(currInfoPlayer.UCID, "^7Please contact the administrator");
            }
    }

        #region delete drift/laptime records
        public void deletedriftrecords(GLScript.unionVal val, ArrayList args)
        {
            infoPlayer currInfoPlayer = newCfg.getCurrInfoPlayer();
            string track = currState.ShortTrackName;
            string ident = val.nameFunction;
            if ((args[0].ToString() != "") || (args[1].ToString() != "")||(args.Count == 2))
            {
                //                                  Username            Car            track
                driftSqlDbs.deletetrackrecords(args[0].ToString(), args[1].ToString(), track);
            } 
            else
            {
                throw new GLScript.GLApp.GLScriptException("ERROR on Function: '" + ident+ "' Incorrect number of parameters or parameters are wrong");
            }
        }

        public void deletelaptimerecords(GLScript.unionVal val, ArrayList args)
        {
            infoPlayer currInfoPlayer = newCfg.getCurrInfoPlayer();
            string track = currState.ShortTrackName;
            string ident = val.nameFunction;
            if ((args[0].ToString() != "") || (args[1].ToString() != "") || (args.Count == 2))
            {
                //                                  Username            Car            track
                gripSqlDbs.deletetrackrecords(args[0].ToString(), args[1].ToString(), track);
            }
            else
            {
                throw new GLScript.GLApp.GLScriptException("ERROR on Function: '" + ident + "' Incorrect number of parameters or parameters are wrong");
            }
        }
        #endregion
        #region Streetcode Yisc[NL]
        public void registerstreetaction(GLScript.unionVal val, ArrayList args)
        {
            infoPlayer currInfoPlayer = newCfg.getCurrInfoPlayer();
            string ident = val.nameFunction;
            // string idTask = "";
            // idTask = args[0].ToString();
            testArgs(ident, "SSSSS", args);
            //                      taskID            TrackName          Desc                CmdEnter              CmdLeave
            listOfStreetEvent.Add(args[0].ToString(), args[1].ToString(), args[2].ToString(), args[3].ToString(), args[4].ToString());
        }
        public void removestreetaction(GLScript.unionVal val, ArrayList args)
        {
            infoPlayer currInfoPlayer = newCfg.getCurrInfoPlayer();
            string ident = val.nameFunction;
            testArgs(ident, "SS", args); // ident Task, track
            listOfZoneEvent.Remove(args[0].ToString(), args[1].ToString());
        }
        #endregion
        public void layoutinfo(GLScript.unionVal val, ArrayList args)
        {
            infoPlayer currInfoPlayer = newCfg.getCurrInfoPlayer();
            PlayerLayoutInfoRequest = currInfoPlayer.UCID;

            byte[] axi = myEncoder.AXI();
            insimConnection.Send(axi, axi.Length);
        }

        public void connectinfo(GLScript.unionVal val, ArrayList args)
        {
            byte[] nci = myEncoder.NCI();
            insimConnection.Send(nci, nci.Length);
        }

        public void trackuserdistance(GLScript.unionVal val, ArrayList args)
        {
            string ident = val.nameFunction;
            bool FunctionError = false;
            int Player_one_X = 0;
            int Player_one_Y = 0;
            int Player_two_X = 0;
            int Player_two_Y = 0;
            try
            {
                //===================================
                //Player/Object 1
                //===================================
                try //Detect Player
                {
                    infoPlayer Player_one;
                    Player_one = listOfPlayers.getPlayerByUserName(args[0].ToString());
                    if (Player_one.userName != "")
                    {
                        //get X-axis of player 1: args[0]
                        Player_one_X = Player_one.x;
                        Player_one_Y = Player_one.y;
                    }
                }
                catch //Detect object
                {
                    string[] object_args_one = args[0].ToString().Split(':');
                    if ((object_args_one[0] == "") || (object_args_one[1] == ""))//X-axis
                    {
                        FunctionError = true;
                    }
                    else
                    {
                        Player_one_X = int.Parse(object_args_one[0].ToString());
                        Player_one_Y = int.Parse(object_args_one[1].ToString());
                    }
                }
                //===================================
                //Player/Object 2
                //===================================
                try //Detect Player
                {
                    infoPlayer Player_two;
                    Player_two = listOfPlayers.getPlayerByUserName(args[1].ToString());
                    if (Player_two.userName != "")
                    {
                        //get X-axis of player 2: args[1]
                        Player_two_X = Player_two.x;
                        Player_two_Y = Player_two.y;
                    }
                }
                catch //Detect object
                {
                    string[] object_args_two = args[1].ToString().Split(':');
                    if ((object_args_two[0] == "") || (object_args_two[1] == ""))//X-axis
                    {
                        FunctionError = true;
                    }
                    else
                    {
                        Player_two_X = int.Parse(object_args_two[0].ToString());
                        Player_two_Y = int.Parse(object_args_two[1].ToString());
                    }
                }
                //calculate X and Y 
                int DistX = Player_one_X - Player_two_X;
                int DistY = Player_one_Y - Player_two_Y;

                float DistanceBetweenPlayers = (float)Math.Sqrt((DistX * DistX) + (DistY * DistY));

                //calculate X and Y
                if (FunctionError == false)
                {
                    val.fval = DistanceBetweenPlayers;
                    val.typVal = GLScript.typVal.num;
                }
                else
                {
                    val.sval = "\"^1ERROR\"";
                    val.typVal = GLScript.typVal.str;
                }
            }
            catch
            {
                val.sval = "\"^1STRING ERROR\"";
                val.typVal = GLScript.typVal.str;
            }
        }

        public void objectinfo(GLScript.unionVal val, ArrayList args)
        {
            byte[] axm = myEncoder.AXM();
            insimConnection.Send(axm, axm.Length);
        }

        #region Add/Remove objects
        public void addobject(GLScript.unionVal val, ArrayList args)
        {
            //byte NumO, byte UCID, byte PMOAction, byte PMOFlags, short X, short Y, byte Z, byte Flags, byte Index, byte Heading
            infoPlayer currInfoPlayer = newCfg.getCurrInfoPlayer();
            string ident = val.nameFunction;
            int Numberofobjects = args.Count; //count numbers of args
            byte ActionPMO = 1;
            byte PMOFlags = 1;
            byte FunctionError = 0;

            //arrays of objects (Max 30 objects)
            short[] Obj_X = new short[Numberofobjects];
            short[] Obj_Y = new short[Numberofobjects];
            byte[] Obj_Z = new byte[Numberofobjects];
            byte[] Obj_Flag = new byte[Numberofobjects];
            byte[] Obj_Index = new byte[Numberofobjects];
            byte[] Obj_Heading = new byte[Numberofobjects];

            if (Numberofobjects <= 30)
            {
                for (byte i = 0; i < Numberofobjects; i++)
                {

                    string[] obj = args[i].ToString().Split(':'); //Split string
                    if ((obj[0] != "") && (obj[1] != "") && (obj[2] != "") && (obj[3] != "") && (obj[4] != "") && (obj[5] != ""))
                    {

                        Obj_X[i] = short.Parse(obj[0].ToString()); //short X
                        Obj_Y[i] = short.Parse(obj[1].ToString()); //short Y
                        Obj_Z[i] = byte.Parse(obj[2].ToString()); //short Z
                        Obj_Flag[i] = byte.Parse(obj[3].ToString()); //byte flag
                        Obj_Index[i] = byte.Parse(obj[4].ToString()); //byte Index
                        Obj_Heading[i] = byte.Parse(obj[5].ToString()); //byte Heading
                        //Console.WriteLine("Number of added object: [" + i + "] X:" + Obj_X[i] + " Y:" + Obj_Y[i] + " Z:" + Obj_Z[i] + " Flag:" + Obj_Flag[i] + " Index:" + Obj_Index[i] + " Heading:" + Obj_Heading[i]);
                    }
                    else
                    {
                        FunctionError = 1;
                        //Console.WriteLine("Function '" + ident + "' Object:[" + i + "] incorrect number of parameters");
                        throw new GLScript.GLApp.GLScriptException("Error Function '" + ident + "': Object:[" + i + "] incorrect number of parameters");
                    }
                }

                if (FunctionError == 0)
                {
                    byte[] axm = myEncoder.AXM(byte.Parse(Numberofobjects.ToString()), //byte NumO
                                                byte.Parse(currInfoPlayer.UCID.ToString()), //byte UCID
                                                byte.Parse(ActionPMO.ToString()), //byte PMOAction
                                                byte.Parse(PMOFlags.ToString()), //byte PMOFlags
                                                Obj_X, //short X
                                                Obj_Y, //short Y
                                                Obj_Z, //short Z
                                                Obj_Flag, //Flag of object
                                                Obj_Index, //byte Index
                                                Obj_Heading); //byte Heading
                    insimConnection.Send(axm, axm.Length);
                }
            }
            else
            {
                throw new GLScript.GLApp.GLScriptException("Error Function '" + ident + "': Contains to many objects (Max 30)");
            }
        }
        public void removeobject(GLScript.unionVal val, ArrayList args)
        {
            //byte NumO, byte UCID, byte PMOAction, byte PMOFlags, short X, short Y, byte Z, byte Flags, byte Index, byte Heading
            infoPlayer currInfoPlayer = newCfg.getCurrInfoPlayer();
            string ident = val.nameFunction;
            int Numberofobjects = args.Count; //count numbers of args
            byte ActionPMO = 2;
            byte PMOFlags = 1;
            byte FunctionError = 0;

            //arrays of objects (Max 30 objects)
            short[] Obj_X = new short[Numberofobjects];
            short[] Obj_Y = new short[Numberofobjects];
            byte[] Obj_Z = new byte[Numberofobjects];
            byte[] Obj_Flag = new byte[Numberofobjects];
            byte[] Obj_Index = new byte[Numberofobjects];
            byte[] Obj_Heading = new byte[Numberofobjects];

            if (Numberofobjects <= 30)
            {
                for (byte i = 0; i < Numberofobjects; i++)
                {
                    string[] obj = args[i].ToString().Split(':'); //Split string
                    if ((obj[0] != "") && (obj[1] != "") && (obj[2] != "") && (obj[3] != "") && (obj[4] != "") && (obj[5] != ""))
                    {

                        Obj_X[i] = short.Parse(obj[0].ToString()); //short X
                        Obj_Y[i] = short.Parse(obj[1].ToString()); //short Y
                        Obj_Z[i] = byte.Parse(obj[2].ToString()); //short Z
                        Obj_Flag[i] = byte.Parse(obj[3].ToString()); //byte flag
                        Obj_Index[i] = byte.Parse(obj[4].ToString()); //byte Index
                        Obj_Heading[i] = byte.Parse(obj[5].ToString()); //byte Heading
                        //Console.WriteLine("Number of added object: [" + i + "] X:" + Obj_X[i] + " Y:" + Obj_Y[i] + " Z:" + Obj_Z[i] + " Flag:" + Obj_Flag[i] + " Index:" + Obj_Index[i] + " Heading:" + Obj_Heading[i]);
                    }
                    else
                    {
                        FunctionError = 1;
                        //Console.WriteLine("Function '" + ident + "' Object:[" + i + "] incorrect number of parameters");
                        throw new GLScript.GLApp.GLScriptException("Error Function '" + ident + "' Object: [" + i + "] incorrect number of parameters");
                    }
                }
                if (FunctionError == 0)
                {
                    byte[] axm = myEncoder.AXM(byte.Parse(Numberofobjects.ToString()), //byte NumO
                                                byte.Parse(currInfoPlayer.UCID.ToString()), //byte UCID
                                                byte.Parse(ActionPMO.ToString()), //byte PMOAction
                                                byte.Parse(PMOFlags.ToString()), //byte PMOFlags
                                                Obj_X, //short X
                                                Obj_Y, //short Y
                                                Obj_Z, //short Z
                                                Obj_Flag, //Flag of object
                                                Obj_Index, //byte Index
                                                Obj_Heading); //byte Heading
                    insimConnection.Send(axm, axm.Length);
                }
            }
            else
            {
                throw new GLScript.GLApp.GLScriptException("Error Function '" + ident + "': Contains to many objects (Max 30)");
            }
        }
        #endregion
        #region Set allowed cars
        public void setallowedcars(GLScript.unionVal val, ArrayList args)
        {
            int CarValue = 0;
            byte i = 0;
            string[] cars = args[0].ToString().Split('+');
            foreach (string car in cars)
            {
                #region carvalues 
                switch (car.ToUpper())
                {
                    case "UF1":
                        CarValue = CarValue + 256;
                        break;
                    case "XFG":
                        CarValue = CarValue + 1;
                        break;
                    case "XRG":
                        CarValue = CarValue + 2;
                        break;
                    case "XRT":
                        CarValue = CarValue + 4;
                        break;
                    case "RB4":
                        CarValue = CarValue + 8;
                        break;
                    case "FXO":
                        CarValue = CarValue + 16;
                        break;
                    case "FZ5":
                        CarValue = CarValue + 1024;
                        break;
                    case "RAC":
                        CarValue = CarValue + 512;
                        break;
                    case "LX4":
                        CarValue = CarValue + 32;
                        break;
                    case "LX6":
                        CarValue = CarValue + 64;
                        break;
                    case "FXR":
                        CarValue = CarValue + 32768;
                        break;
                    case "XRR":
                        CarValue = CarValue + 65536;
                        break;
                    case "FZR":
                        CarValue = CarValue + 131072;
                        break;
                    case "UFR":
                        CarValue = CarValue + 8192;
                        break;
                    case "XFR":
                        CarValue = CarValue + 4096;
                        break;
                    case "FOX":
                        CarValue = CarValue + 2048;
                        break;
                    case "F08":
                        CarValue = CarValue + 16384;
                        break;
                    case "MRT":
                        CarValue = CarValue + 128;
                        break;
                    case "FBM":
                        CarValue = CarValue + 524288;
                        break;
                    case "BF1":
                        CarValue = CarValue + 262144;
                        break;
                }
                #endregion
                i++;
            }
            byte[] alc = myEncoder.ALC(int.Parse(CarValue.ToString()));
            insimConnection.Send(alc, alc.Length);
        }

        public void allowedplayercars(GLScript.unionVal val, ArrayList args)
        {
            infoPlayer currInfoPlayer;
            currInfoPlayer = listOfPlayers.getPlayerByUserName(args[0].ToString());
            int CarValue = 0;
            byte i = 0;
            string[] cars = args[1].ToString().Split('+');
            foreach (string car in cars)
            {
                #region carvalues 
                switch (car.ToUpper())
                {
                    case "UF1":
                        CarValue = CarValue + 256;
                        break;
                    case "XFG":
                        CarValue = CarValue + 1;
                        break;
                    case "XRG":
                        CarValue = CarValue + 2;
                        break;
                    case "XRT":
                        CarValue = CarValue + 4;
                        break;
                    case "RB4":
                        CarValue = CarValue + 8;
                        break;
                    case "FXO":
                        CarValue = CarValue + 16;
                        break;
                    case "FZ5":
                        CarValue = CarValue + 1024;
                        break;
                    case "RAC":
                        CarValue = CarValue + 512;
                        break;
                    case "LX4":
                        CarValue = CarValue + 32;
                        break;
                    case "LX6":
                        CarValue = CarValue + 64;
                        break;
                    case "FXR":
                        CarValue = CarValue + 32768;
                        break;
                    case "XRR":
                        CarValue = CarValue + 65536;
                        break;
                    case "FZR":
                        CarValue = CarValue + 131072;
                        break;
                    case "UFR":
                        CarValue = CarValue + 8192;
                        break;
                    case "XFR":
                        CarValue = CarValue + 4096;
                        break;
                    case "FOX":
                        CarValue = CarValue + 2048;
                        break;
                    case "F08":
                        CarValue = CarValue + 16384;
                        break;
                    case "MRT":
                        CarValue = CarValue + 128;
                        break;
                    case "FBM":
                        CarValue = CarValue + 524288;
                        break;
                    case "BF1":
                        CarValue = CarValue + 262144;
                        break;
                }
                #endregion
                i++;
            }
            byte[] plc = myEncoder.PLC(byte.Parse(currInfoPlayer.UCID.ToString()), int.Parse(CarValue.ToString()));
            insimConnection.Send(plc, plc.Length);
        }
   #endregion
        public void joinrequest(GLScript.unionVal val, ArrayList args)
        {
            //convert objects from string to integer
            int FLags = Int16.Parse(args[3].ToString());
            int Heading = Int16.Parse(args[4].ToString());
            int PLID = Int16.Parse(args[6].ToString());

            string ident = val.nameFunction;
            if (args.Count < 8)
                throw new GLScript.GLApp.GLScriptException("Command '" + ident + "' incorrect number of parameters");
            else
            {
                if (Heading >= 255) //If heading value is larger than 255 (byte type!)
                    throw new GLScript.GLApp.GLScriptException("Error on Command: '" + ident + "'  Value of 'Heading' must be lower than 255");
                else
                {
                    if (FLags == 128 && PLID == -1)
                        throw new GLScript.GLApp.GLScriptException("Warning on Command: '" + ident + "' Cannot spawn spectating players");
                    else
                    {
                        byte[] jrr = myEncoder.JRR(short.Parse(args[0].ToString()), short.Parse(args[1].ToString()), byte.Parse(args[2].ToString()), byte.Parse(args[3].ToString()), byte.Parse(args[4].ToString()), byte.Parse(args[5].ToString()), byte.Parse(args[6].ToString()), byte.Parse(args[7].ToString()));
                        insimConnection.Send(jrr, jrr.Length);
                    }
                }
            }
        }
        public void startlightcontrol(GLScript.unionVal val, ArrayList args)
        {
            string ident = val.nameFunction;
            if (args.Count < 4)
            {
                throw new GLScript.GLApp.GLScriptException("Command '" + ident + "' incorrect number of parameters");
            }
            else
            {
                byte[] oco = myEncoder.OCO(byte.Parse(args[0].ToString()), byte.Parse(args[1].ToString()), byte.Parse(args[2].ToString()), byte.Parse(args[3].ToString()));
                insimConnection.Send(oco, oco.Length);
            }
        }
        void testArgs(string ident, string pattern, System.Collections.ArrayList args)
		{
			if (pattern.Length != args.Count)
			{
				throw new GLScript.GLApp.GLScriptException("Command '" + ident + "' incorrect number of parameters");
			}
			for (int i = 0; i < pattern.Length; i++)
			{
				if (pattern[i] == 'I')
				{
					try
					{
						int val = int.Parse(args[i].ToString());

					}
					catch
					{
						throw new GLScript.GLApp.GLScriptException("'" + ident + "' parameter #" + i.ToString() + "(" + args[i] + ") is wrong type at line #");
					}
				}
				if (pattern[i] == 'F')
				{
					try
					{
						float val = float.Parse(args[i].ToString());

					}
					catch
					{
						throw new GLScript.GLApp.GLScriptException("'" + ident + "' parameter #" + i.ToString() + "(" + args[i] + ") is wrong type at line #");
					}
				}
			}
		}
		public void retreiveVarLapper(GLScript.unionVal val, string idVar)
		{
            #region globalVar
            switch (idVar.ToLower())
            {
                case "lapperversion":
                    val.typVal = GLScript.typVal.str;
                    val.sval = "\"" + LFSLapper.getShortVersion(4) + "\"";
                    return;
                case "lfsversion":
                    val.typVal = GLScript.typVal.str;
                    val.sval = "\"" + insimConnection.Version + "\"";
                    return;
                case "lfsmode":
                    val.typVal = GLScript.typVal.str;
                    val.sval = "\"" + insimConnection.Product + "\"";
                    return;

                case "rotatein":
                    val.typVal = GLScript.typVal.num;
                    if (newCfg.varsLapper.EnableRotation)
                        val.fval = newCfg.varsLapper.RotateEveryNbRaces - currRace.racesDone;
                    else
                        val.fval = 0;
                    return;
                case "racelapsleft":
                    val.typVal = GLScript.typVal.num;
                    if (currRace.inRace)
                        val.fval = currRace.raceLapsLeft;
                    else
                        val.fval = 0;
                    return;

                case "hostname":
                    val.typVal = GLScript.typVal.str;
                    val.sval = utils.quote(currentHName);
                    return;
                case "shorttrackname":
                    val.typVal = GLScript.typVal.str;
                    val.sval = utils.quote(currState.ShortTrackName);
                    return;
                case "longtrackname":
                    val.typVal = GLScript.typVal.str;
                    val.sval = utils.quote(UTILS.utils.getLongTrackName(currState.ShortTrackName));
                    return;
                case "trackid":
                    val.typVal = GLScript.typVal.str;
                    val.sval = utils.quote(UTILS.utils.convTrackShortnameToId(currState.ShortTrackName));
                    return;
                case "shorttime":
                    val.typVal = GLScript.typVal.str;
                    val.sval = utils.quote(System.DateTime.Now.ToString(newCfg.varsLapper.ShortTimeFormat));
                    return;
                case "longtime":
                    val.typVal = GLScript.typVal.str;
                    val.sval = utils.quote(System.DateTime.Now.ToString(newCfg.varsLapper.LongTimeFormat));
                    return;
                case "shortdate":
                    val.typVal = GLScript.typVal.str;
                    val.sval = utils.quote(System.DateTime.Now.ToString(newCfg.varsLapper.DateFormat));
                    return;
                case "longdate":
                    val.typVal = GLScript.typVal.str;
                    val.sval = utils.quote(System.DateTime.Now.ToString(newCfg.varsLapper.LongDateFormat));
                    return;
                case "nextrotatecar":
                    {
                        val.typVal = GLScript.typVal.str;
                        int nextCar = currRace.currRotateCar + 1;
                        string[] tmpCars = newCfg.varsLapper.RotateCars.Split(',');
                        if (nextCar > tmpCars.Length - 1)
                            nextCar = 0;
                        val.sval = utils.quote(tmpCars[nextCar]);
                    }
                    return;
                case "nextrotatetrack":
                case "nextlongrotatetrack":
                    {
                        val.typVal = GLScript.typVal.str;
                        int nextTrack = currRace.currRotateTrack + 1;
                        string[] tmpTracks = newCfg.varsLapper.RotateTracks.Split(',');
                        if (nextTrack > tmpTracks.Length - 1)
                            nextTrack = 0;
                        if (idVar == "nextrotatetrack")
                            val.sval = utils.quote(tmpTracks[nextTrack]);
                        else
                            val.sval = utils.quote(UTILS.utils.getLongTrackName(tmpTracks[nextTrack]));

                    }
                    return;
                case "currrotatecar":
                    {
                        val.typVal = GLScript.typVal.str;
                        int nextCar = currRace.currRotateCar;
                        string[] tmpCars = newCfg.varsLapper.RotateCars.Split(',');
                        if (nextCar > tmpCars.Length - 1)
                            nextCar = 0;
                        val.sval = utils.quote(tmpCars[nextCar]);
                    }
                    return;
                case "currrotatetrack":
                case "currlongrotatetrack":
                    {
                        val.typVal = GLScript.typVal.str;
                        int nextTrack = currRace.currRotateTrack;
                        string[] tmpTracks = newCfg.varsLapper.RotateTracks.Split(',');
                        if (nextTrack > tmpTracks.Length - 1)
                            nextTrack = 0;
                        if (idVar == "CurrRotateTrack")
                            val.sval = utils.quote(tmpTracks[nextTrack]);
                        else
                            val.sval = utils.quote(UTILS.utils.getLongTrackName(tmpTracks[nextTrack]));
                    }
                    return;
                case "requiredflags":
                    val.typVal = GLScript.typVal.str;
                    val.sval = utils.quote(sFlagsRequired);
                    return;
                case "nbplayersontrack":
                    val.typVal = GLScript.typVal.num;
                    val.fval = listOfPlayers.nbPlayerOnTrack;
                    return;
                case "dateracestarted":
                    val.typVal = GLScript.typVal.str;
                    val.sval = utils.quote(currRace.started.ToString("yyyy-MM-dd-hh-mm-ss"));
                    return;

                //Retreive Laps/Hours from LFS
                /*
                 // RaceLaps (rl) : (various meanings depending on range)

                 // 0       : practice
                 // 1-99    : number of laps...   laps  = rl
                 // 100-190 : 100 to 1000 laps... laps  = (rl - 100) * 10 + 100
                 // 191-238 : 1 to 48 hours...    hours = rl - 190
                */
                case "racelaps":
                    int laps;
                    if (currState.RaceLaps < 190)
                    {
                        //laps
                        if ((currState.RaceLaps > 100) && (currState.RaceLaps < 190))
                        {

                            laps = ((currState.RaceLaps - 100) * 10 + 100);
                        }
                        else
                        {
                            laps = currState.RaceLaps;
                        }
                    }
                    else
                    {
                        laps = 0; // IF Hours is set Return 0 
                    }
                    val.typVal = GLScript.typVal.num;
                    val.fval = laps;
                    return;

                case "racehours":
                    int hours;
                    if (currState.RaceLaps > 190)
                    {
                        hours = (currState.RaceLaps - 190);
                    }
                    else
                    {
                        hours = 0; // IF Laps is set Return 0 
                    }
                    val.typVal = GLScript.typVal.num;
                    val.fval = hours;
                    return;

                case "raceinprog":
					val.typVal = GLScript.typVal.num;
					val.fval = currState.RaceInProg;
					return;
				case "racemins":
					val.typVal = GLScript.typVal.num;
					val.fval = currRace.raceMins;
					return;
                case "elapsedmins":
                    TimeSpan interval = DateTime.Now.Subtract(currRace.started);
                    val.typVal = GLScript.typVal.num;
                    val.fval = (float)interval.TotalMinutes;
                    return;
                case "elapsedsecs":
                    TimeSpan interval2 = DateTime.Now.Subtract(currRace.started);
					val.typVal = GLScript.typVal.num;
                    val.fval = (float)interval2.TotalSeconds;
					return;

                case "elapsedms":
                    TimeSpan intervalms = DateTime.Now.Subtract(currRace.started);
					val.typVal = GLScript.typVal.num;
                    val.fval = (float)intervalms.TotalMilliseconds;
					return;
                case "numfinished":
                    val.typVal = GLScript.typVal.num;
                    val.fval = currState.NumFinished;
                    return;
                case "racetime":
                    Timer = GetRaceTimer(Timer);
                    val.typVal = GLScript.typVal.num;
                    val.fval = Timer * 10;
                    return;
                case "allowedcars":
                    val.typVal = GLScript.typVal.str;
                    val.sval = "\"" + newCfg.varsLapper.AllowedCars + "\"";
                    return;
                case "qualmins":
					val.typVal = GLScript.typVal.num;
					val.fval = currRace.qualMins;
					return;
				case "numconns":
					val.typVal = GLScript.typVal.num;
					val.fval = currState.NumConns;
					return;
                case "wind":
                    val.typVal = GLScript.typVal.num;
                    val.fval = currState.Wind;
                    return;
                case "weather":
                    val.typVal = GLScript.typVal.num;
                    val.fval = (currState.Weather+1);
                    return;
                case "numplayers":
					val.typVal = GLScript.typVal.num;
					val.fval = currState.NumP;
					return;
                #region RaceFlags
                case "canvote": //Guests may vote
                    val.typVal = GLScript.typVal.num;
                    if ((currRace.raceFlags & 1) == 1)
                        val.fval = 1;
                    else
                        val.fval = 0;
                    return;
                case "canselect": //Guests can select car/track
                    val.typVal = GLScript.typVal.num;
                    if ((currRace.raceFlags & 2) == 2)
                        val.fval = 1;
                    else
                        val.fval = 0;
                    return;
                case "midracejoin": //Guests are allowed to join during a race
                    val.typVal = GLScript.typVal.num;
                    if ((currRace.raceFlags & 32) == 32)
                        val.fval = 1;
                    else
                        val.fval = 0;
                    return;
                case "mustpit": //Guests must pit during a race
                    val.typVal = GLScript.typVal.num;
                    if ((currRace.raceFlags & 64) == 64)
                        val.fval = 1;
                    else
                        val.fval = 0;
                    return;
                case "canreset": //Guests may reset theire car
                    val.typVal = GLScript.typVal.num;
                    if ((currRace.raceFlags & 128) == 128)
                        val.fval = 1;
                    else
                        val.fval = 0;
                    return;
                case "forcedcockpitview": //Guests are forced to use cockpitview
                    val.typVal = GLScript.typVal.num;
                    if ((currRace.raceFlags & 256) == 256)
                        val.fval = 1;
                    else
                        val.fval = 0;
                    return;
                case "cruise": //Guests are allowed to drive wrong way
                    val.typVal = GLScript.typVal.num;
                    if ((currRace.raceFlags & 512) == 512)
                        val.fval = 1;
                    else
                        val.fval = 0;
                    return;
                case "timing": //Type of Timing
                    val.typVal = GLScript.typVal.num;
                    if ((currRace.timing & 64) == 64)
                        val.fval = 1;
                    if ((currRace.timing & 128) == 128)
                        val.fval = 2;
                    if ((currRace.timing & 192) == 192)
                        val.fval = 0;
                    return;

                case "nbofcheckpoints": //Number of checkpoints (0 ,1,2 or 3) Insim checkpoints does not count
                    val.typVal = GLScript.typVal.num;
                    if ((currRace.timing & 192) == 192) //No laptiming, See 'timing' var
                        val.fval = 0;
                    if ((currRace.timing & 1) == 1) //1 checkpoint
                        val.fval = 1;
                    if ((currRace.timing & 2) == 2) //2 checkpoints
                        val.fval = 2;
                    if ((currRace.timing & 3) == 3) //3 checkpoints
                        val.fval = 3;
                    return;
                #endregion
                default:
					val.typVal = GLScript.typVal.str;
					val.sval = utils.quote("");
					return;
			}
			#endregion
		}
        public void getplayerinfo(GLScript.unionVal val, ArrayList args)
        {
            infoPlayer currInfoPlayer = newCfg.getCurrInfoPlayer();
            infoPlayer currPly = null;
            if (args.Count > 0)
            {
                testArgs("getplayerinfo", "S", args);
                currPly = listOfPlayers.getPlayerByUserName((string)args[0]);
            }
            else
            {
                currPly = listOfPlayers.getPlayerByUserName((string)currInfoPlayer.userName);
            }
            if (currPly == null)
            {
                val.typVal = GLScript.typVal.str;
                val.sval = utils.quote("");
                return;
            }
            val.typVal = GLScript.typVal.setOfVar;
            val.setVars = new GLScript.SetOfVars();

            foreach (string pvar in Enum.GetNames(typeof(playerVars)))
            {
                val.setVars.Set(utils.quote(pvar), currPly.playerVars.Get(utils.quote(pvar)));
            }
        }

        #region Button functions
        public void openprivbutton(GLScript.unionVal val, ArrayList args)
		{

			infoPlayer currInfoPlayer = newCfg.getCurrInfoPlayer();
			string ident = val.nameFunction;
			if (currInfoPlayer == null)
				throw new GLScript.GLApp.GLScriptException("You can't use " + ident + " in this context, not a player event");
			if (args.Count == 9)
				args.Add("");
			testArgs(ident, "SIIIIIIISS", args);
			string text = args[8].ToString();
			if (text == "[[TranslateEngine]]")
				text = lfsLang.replaceParmsLangStr(currInfoPlayer.idLang);
			currInfoPlayer.playerBox.create(
												args[0].ToString(), // ID du boutton
												currInfoPlayer.UCID,
												int.Parse(args[1].ToString()), // X
												int.Parse(args[2].ToString()), // Y
												int.Parse(args[3].ToString()),  // Largeur
												int.Parse(args[4].ToString()),  // Hauteur
												int.Parse(args[5].ToString()),  // Interligne
												int.Parse(args[6].ToString()), // Sec Visible
												0,                              // TypeIn
												int.Parse(args[7].ToString()),  // Bstyle
												"",                             // Caption
												text,             // Button Text
												args[9].ToString()              // BackCall
			);
			currInfoPlayer.playerBox.show(args[0].ToString(), currInfoPlayer.UCID);

		}
		public void closeprivbutton(GLScript.unionVal val, ArrayList args)
		{
			infoPlayer currInfoPlayer = newCfg.getCurrInfoPlayer();
			string ident = val.nameFunction;
			if (currInfoPlayer == null)
				throw new GLScript.GLApp.GLScriptException("You can't use " + ident + " in this context, not a player event");
			testArgs(ident, "S", args);
			currInfoPlayer.privateButtonClose(args[0].ToString());
		}
		public void openbutton(GLScript.unionVal val, ArrayList args)
		{

			infoPlayer currPly;
			string ident = val.nameFunction;
            currPly = listOfPlayers.getPlayerByUserName((string)args[0]);
			if (currPly == null)
			{
				throw new GLScript.GLApp.GLScriptException("Player name " + (string)args[0] + " in function " + ident + " not a player");
			}
			args.RemoveAt(0);
			if (args.Count == 9)
				args.Add("");
			testArgs(ident, "SIIIIIIISS", args);
			string text = args[8].ToString();
			if (text == "[[TranslateEngine]]")
				text = lfsLang.replaceParmsLangStr(currPly.idLang);
			currPly.playerBox.create(
												args[0].ToString(), // ID du boutton
												currPly.UCID,
												int.Parse(args[1].ToString()), // X
												int.Parse(args[2].ToString()), // Y
												int.Parse(args[3].ToString()),  // Largeur
												int.Parse(args[4].ToString()),  // Hauteur
												int.Parse(args[5].ToString()),  // Interligne
												int.Parse(args[6].ToString()), // Sec Visible
												0,                              // TypeIn
												int.Parse(args[7].ToString()),  // Bstyle
												"",                             // Caption
												text,             // Button Text
												args[9].ToString()              // BackCall
			);
			currPly.playerBox.show(args[0].ToString(), currPly.UCID);

		}
		public void opentextbutton(GLScript.unionVal val, ArrayList args)
		{
			infoPlayer currPly = newCfg.getCurrInfoPlayer();
			string ident = val.nameFunction;
			currPly = listOfPlayers.getPlayerByUserName((string)args[0]);
			if (currPly == null)
			{
				throw new GLScript.GLApp.GLScriptException("Player name " + (string)args[0] + " in function " + ident + " not a player");
			}
			args.RemoveAt(0);
			testArgs(ident, "SIIIIIISSIS", args);
			string text = args[8].ToString();
			if (text == "[[TranslateEngine]]")
				text = lfsLang.replaceParmsLangStr(currPly.idLang);

			currPly.playerBox.create(args[0].ToString(), // ID du boutton
												currPly.UCID,
												int.Parse(args[1].ToString()),  // X
												int.Parse(args[2].ToString()),  // Y
												int.Parse(args[3].ToString()),  // Largeur
												int.Parse(args[4].ToString()),  // Hauteur
												int.Parse(args[5].ToString()),  // Interligne
												-1,                              // Sec Visible
												int.Parse(args[9].ToString()),  // TypeIn
												int.Parse(args[6].ToString()),  // Bstyle
												args[7].ToString(),             // Caption
												text,            // Button Text
												args[10].ToString()             // BackCall
			);
			currPly.playerBox.show(args[0].ToString(), currPly.UCID);
		}
		public void closebutton(GLScript.unionVal val, ArrayList args)
		{
			infoPlayer currPly;
			string ident = val.nameFunction;
			currPly = listOfPlayers.getPlayerByUserName((string)args[0]);
			if (currPly == null)
			{
				throw new GLScript.GLApp.GLScriptException("Player name " + (string)args[0] + " in function " + ident + " not a player");
			}
			args.RemoveAt(0);
			testArgs(ident, "S", args);
			currPly.privateButtonClose(args[0].ToString());
		}
        #endregion
        public void getlistoflang(GLScript.unionVal val, ArrayList args)
		{
			string ident = val.nameFunction;

			string[] lang = lfsLang.getAllLang();

			val.typVal = GLScript.typVal.setOfVar;
			val.setVars = new GLScript.SetOfVars();
			for (int i = 0; i < lang.Length; i++)
			{
				val.setVars.Set(i.ToString(), new GLScript.unionVal(0, utils.quote(lang[i]), GLScript.typVal.str));
			}
		}
		public void getwr(GLScript.unionVal val, ArrayList args)
		{
            string ident = val.nameFunction;

            infoPlayer currInfoPlayer = newCfg.getCurrInfoPlayer();
            if (currInfoPlayer == null)
                throw new GLScript.GLApp.GLScriptException("You can't use " + ident + " in this context, not a player event");

			val.typVal = GLScript.typVal.setOfVar;
			val.setVars = new GLScript.SetOfVars();

            wr.wrInfo wi = currWr.getWR(currState.ShortTrackName, currInfoPlayer.CName);
            if (wi == null)
            {
                val.setVars.Set(utils.quote("CName"), new GLScript.unionVal(0, utils.quote(""), GLScript.typVal.str));
                val.setVars.Set(utils.quote("Track"), new GLScript.unionVal(0, utils.quote(""), GLScript.typVal.str));
                val.setVars.Set(utils.quote("racerName"), new GLScript.unionVal(0, utils.quote(""), GLScript.typVal.str));
                val.setVars.Set(utils.quote("WRTime"), new GLScript.unionVal(0, utils.quote("0"), GLScript.typVal.str));
                val.setVars.Set(utils.quote("Split1"), new GLScript.unionVal(0, utils.quote("0"), GLScript.typVal.str));
                val.setVars.Set(utils.quote("Split2"), new GLScript.unionVal(0, utils.quote("0"), GLScript.typVal.str));
                val.setVars.Set(utils.quote("Split3"), new GLScript.unionVal(0, utils.quote("0"), GLScript.typVal.str));
                val.setVars.Set(utils.quote("SectorLast"), new GLScript.unionVal(0, utils.quote("0"), GLScript.typVal.str));
            }
            else
            {
                val.setVars.Set(utils.quote("CName"), new GLScript.unionVal(0, utils.quote(wi.CName), GLScript.typVal.str));
                val.setVars.Set(utils.quote("Track"), new GLScript.unionVal(0, utils.quote(wi.track), GLScript.typVal.str));
                val.setVars.Set(utils.quote("racerName"), new GLScript.unionVal(0, utils.quote(wi.racerName), GLScript.typVal.str));
                val.setVars.Set(utils.quote("WRTime"), new GLScript.unionVal(0, utils.quote(wi.WRTime.ToString()), GLScript.typVal.str));
                val.setVars.Set(utils.quote("Split1"), new GLScript.unionVal(0, utils.quote(wi.split[0].ToString()), GLScript.typVal.str));
                val.setVars.Set(utils.quote("Split2"), new GLScript.unionVal(0, utils.quote(wi.split[1].ToString()), GLScript.typVal.str));
                val.setVars.Set(utils.quote("Split3"), new GLScript.unionVal(0, utils.quote(wi.split[2].ToString()), GLScript.typVal.str));
                val.setVars.Set(utils.quote("SectorLast"), new GLScript.unionVal(0, utils.quote(wi.sectorSplitLast.ToString()), GLScript.typVal.str));
            }
        }
		public void striplfscolor(GLScript.unionVal val, ArrayList args)
		{
			string ident = val.nameFunction;
			testArgs(ident, "S", args);
			val.typVal = GLScript.typVal.str;
			val.sval = utils.quote(UTILS.utils.stripLFSColor( (string)args[0] ));
		}
		public void setracegrid(GLScript.unionVal val, ArrayList args)
		{
			string ident = val.nameFunction;

            if (args.Count == 1)
            {
                testArgs(ident, "S", args);
				//string subF = "";
            }
            else if (args.Count == 2)
            {
                testArgs(ident, "SS", args);
				//string subF = (string)args[1];
			}

//            for (int i = 0; i < currGridOrder.Length - 1; i++)
//                currGridOrder[i] = 0;


/*			// Loop through the comma separated string provided for new race order as PLIDs
			string[] thisPLID = args[0].ToString().Split(',');
			for (int i = 0; i < thisPLID.Length; i++)
			{
				try
				{
                    currGridOrder[i] = int.Parse(thisPLID[i].ToString());
				}
				catch
				{
					throw new GLScript.GLApp.GLScriptException("'" + ident + "' parameter #" + i.ToString() + "(" + thisPLID[i] + ") is wrong type at line #");
				}
			}
*/
            val.typVal = GLScript.typVal.str;
			val.sval = utils.quote("");
		}
		public void requestreo(GLScript.unionVal val, ArrayList args)
		{
			// Request an REO packet
			byte[] reo = myEncoder.REO(250);
			insimConnection.Send(reo, reo.Length);
            val.typVal = GLScript.typVal.str;
            val.sval = utils.quote("");
		}
        public void getlayoutinfo(GLScript.unionVal val, ArrayList args)
        {
            // Request an AXI packet
            byte[] axi = myEncoder.AXI();
            insimConnection.Send(axi, axi.Length);
            val.typVal = GLScript.typVal.str;
            val.sval = utils.quote("");
        }
        public void getlistofplayers(GLScript.unionVal val, ArrayList args)
		{
            string ident = val.nameFunction;
            ArrayList lply = new ArrayList();

            val.typVal = GLScript.typVal.setOfVar;
            val.setVars = new GLScript.SetOfVars();
            foreach (DictionaryEntry de in listOfPlayers.playersUCID)
            {
                infoPlayer CI = (infoPlayer)de.Value;
                if (CI.UCID == 0)
                    continue;
                lply.Add(new LOP(CI.userName, UTILS.utils.stripLFSColor(CI.nickName)));
            }
            lply.Sort(new sortByUName());
            if (args.Count == 1)
            {
                string sort = (string)args[0];
                if (sort.ToLower() == "n")
                    lply.Sort(new sortByNName());
            }
            for (int i = 0; i < lply.Count; i++)
            {
                val.setVars.Set(i.ToString(), new GLScript.unionVal(0, utils.quote((lply[i] as LOP).userName), GLScript.typVal.str));
            }
        }
		public void setplayervar(GLScript.unionVal val, ArrayList args)
		{
			string ident = val.nameFunction;
            testArgs(ident, "SSS", args);
			SetVarPlayer(val, utils.quote((string)args[1]), (string)args[0], (string)args[2]);
		}
		public void getplayervar(GLScript.unionVal val, ArrayList args)
		{
			string ident = val.nameFunction;
            testArgs(ident, "SS", args);

			infoPlayer currInfoPlayer = listOfPlayers.getPlayerByUserName((string)args[0]);
			if (currInfoPlayer == null)
			{
				val.typVal = GLScript.typVal.str;
				val.sval = utils.quote("");
				return;
			}
			GLScript.unionVal retVal = currInfoPlayer.playerVars.Get(utils.quote((string)args[1]));
			val.typVal = retVal.typVal;
			val.sval = retVal.sval;
			val.fval = retVal.fval;
		}
		public void getplayervarbyucid(GLScript.unionVal val, ArrayList args)
		{
			string ident = val.nameFunction;
            testArgs(ident, "IS", args);

			infoPlayer currInfoPlayer = listOfPlayers.getPlayerByUCID(int.Parse(args[0].ToString()));
			if (currInfoPlayer == null)
			{
				val.typVal = GLScript.typVal.str;
				val.sval = utils.quote("");
				return;
			}
			GLScript.unionVal retVal = currInfoPlayer.playerVars.Get(utils.quote((string)args[1]));
			val.typVal = retVal.typVal;
			val.sval = retVal.sval;
			val.fval = retVal.fval;
		}
		public void getplayervarbyplid(GLScript.unionVal val, ArrayList args)
		{
			string ident = val.nameFunction;
            testArgs(ident, "IS", args);

			infoPlayer currInfoPlayer = listOfPlayers.getPlayerByPLID(int.Parse(args[0].ToString()));
			if (currInfoPlayer == null)
			{
				val.typVal = GLScript.typVal.str;
				val.sval = utils.quote("");
				return;
			}
			GLScript.unionVal retVal = currInfoPlayer.playerVars.Get(utils.quote((string)args[1]));
			val.typVal = retVal.typVal;
			val.sval = retVal.sval;
			val.fval = retVal.fval;
		}
		public void getlappervar(GLScript.unionVal val, ArrayList args)
		{
			string ident = val.nameFunction;
            testArgs(ident, "S", args);

            retreiveVarLapper(val, (string)args[0]);
		}
		public void getconfigvar(GLScript.unionVal val, ArrayList args)
		{
			string ident = val.nameFunction;
            testArgs(ident, "S", args);
            getConfigVar(val, (string)args[0]);

		}
		public void setconfigvar(GLScript.unionVal val, ArrayList args)
		{
			string ident = val.nameFunction;
            testArgs(ident, "SS", args);
            setConfigVar(val, (string)args[0], (string)args[1]);
		}
		public void numtomsh(GLScript.unionVal val, ArrayList args)
		{
			string ident = val.nameFunction;
            testArgs(ident, "S", args);
            val.typVal = GLScript.typVal.str;
            try
            {
                val.sval = utils.quote(unitConv.LongToHMS(long.Parse((string)args[0])));
            }
            catch
            {
                val.sval = "";
            }
		}
        public void numtoms(GLScript.unionVal val, ArrayList args)
        {
            string ident = val.nameFunction;
            testArgs(ident, "S", args);
            val.typVal = GLScript.typVal.str;
            try
            {
                val.sval = utils.quote(unitConv.LongToMS(long.Parse((string)args[0])));
            }
            catch
            {
                val.sval = "";
            }
        }
		public void mshtonum(GLScript.unionVal val, ArrayList args)
		{
			string ident = val.nameFunction;
			testArgs(ident, "S", args);
			val.typVal = GLScript.typVal.num;
			val.fval = unitConv.HMSToLong(args[0].ToString());
		}
		public void tokph(GLScript.unionVal val, ArrayList args)
		{
			string ident = val.nameFunction;
            testArgs(ident, "F", args);
            val.typVal = GLScript.typVal.num;
            val.fval = (float)unitConv.toKph(float.Parse(args[0].ToString()));
		}
		public void tomph(GLScript.unionVal val, ArrayList args)
		{
			string ident = val.nameFunction;
            testArgs(ident, "F", args);
            val.typVal = GLScript.typVal.num;
            val.fval = (float)unitConv.toMph(float.Parse(args[0].ToString()));
		}
		public void toplayerunit(GLScript.unionVal val, ArrayList args)
		{
			infoPlayer currInfoPlayer = newCfg.getCurrInfoPlayer();
			string ident = val.nameFunction;
            testArgs(ident, "F", args);
            if (currInfoPlayer == null)
                throw new GLScript.GLApp.GLScriptException("You can't use " + ident + " in this context, not a player event");
            val.typVal = GLScript.typVal.num;
            val.fval = float.Parse(string.Format("{0:n}", unitConv.getSpeed(currInfoPlayer.unitSpeedKmh, float.Parse(args[0].ToString()))));
		}
		public void langtranslate(GLScript.unionVal val, ArrayList args)
		{
			infoPlayer currInfoPlayer = newCfg.getCurrInfoPlayer();
			string ident = val.nameFunction;
            string lang = "en";
            if (args.Count < 1)
                throw new GLScript.GLApp.GLScriptException("Error on Command '" + ident + "' incorrect number of parameters");
            if (currInfoPlayer != null)
                lang = currInfoPlayer.idLang;
            string tmpStr = (string)args[0];
            tmpStr = lfsLang.replaceLangStr(lang, tmpStr);
            args.RemoveAt(0);
            try
            {
                val.sval = "\"" + string.Format(tmpStr, args.ToArray()) + "\"";
            }
            catch
            {
                val.sval = "\"" + "Wrong format " + tmpStr + "\"";
            }
            val.typVal = GLScript.typVal.str;
		}
		public void langengine(GLScript.unionVal val, ArrayList args)
		{
			string ident = val.nameFunction;
            if (args.Count < 1)
                throw new GLScript.GLApp.GLScriptException("Error on Command '" + ident + "' incorrect number of parameters");
            string tmpStr = (string)args[0];
            args.RemoveAt(0);
            lfsLang.setParmsTranslate(tmpStr, args);
            val.sval = "\"" + "[[TranslateEngine]]" + "\"";
            val.typVal = GLScript.typVal.str;
		}
		public void forcerotation(GLScript.unionVal val, ArrayList args)
		{
            ForceRotation = 1;
            val.typVal = GLScript.typVal.str;
            val.sval = utils.quote("");
		}
		public void termlapper(GLScript.unionVal val, ArrayList args)
		{
            TermProg = true;
            val.typVal = GLScript.typVal.str;
            val.sval = utils.quote("");
		}
		public void groupcmdlfs(GLScript.unionVal val, ArrayList args)
		{
			string ident = val.nameFunction;
			testArgs(ident, "S", args);
            outgoingCmdStack.Enqueue(args[0]);                
		}
		public void cmdlfs(GLScript.unionVal val, ArrayList args)
		{
			string ident = val.nameFunction;
            testArgs(ident, "S", args);
            SendMsg(args[0].ToString()); 
		}
		public void setlicense(GLScript.unionVal val, ArrayList args)
		{
			string ident = val.nameFunction;
            testArgs(ident, "S", args);
            {
                string arg = args[0].ToString().Trim().ToLower();
                if (arg == "on")
                {
                    SendMsg("License ON");
                    SystemAuth.AuthOn = true;
                }
                if (arg == "off")
                {
                    SendMsg( "License OFF");
                    SystemAuth.AuthOn = false;
                }
                if (arg == "?" || arg == "")
                {
                    if (SystemAuth.AuthOn)
                        SendMsg("License Status = ON");
                    else
                        SendMsg("License Status = OFF");
                }
            }
		}
		public void setcurrentplayervar(GLScript.unionVal val, ArrayList args)
		{
			infoPlayer currInfoPlayer = newCfg.getCurrInfoPlayer();
			string ident = val.nameFunction;
            testArgs(ident, "SS", args);
            if (currInfoPlayer == null)
                throw new GLScript.GLApp.GLScriptException("You can't use " + ident + " in this context, not a player event");
            SetVarPlayer(val, utils.quote((string)args[0]), currInfoPlayer.userName, (string)args[1]);
		}
		public void getcurrentplayervar(GLScript.unionVal val, ArrayList args)
		{
			infoPlayer currInfoPlayer = newCfg.getCurrInfoPlayer();
			string ident = val.nameFunction;
            testArgs(ident, "S", args);
            if (currInfoPlayer == null)
                throw new GLScript.GLApp.GLScriptException("You can't use " + ident + " in this context, not a player event");

			GLScript.unionVal retVal = currInfoPlayer.playerVars.Get( utils.quote((string)args[0]));
			val.typVal = retVal.typVal;
			val.sval = retVal.sval;
			val.fval = retVal.fval;
		}

		public void privmsg(GLScript.unionVal val, ArrayList args)
		{
			infoPlayer currInfoPlayer = newCfg.getCurrInfoPlayer();
			string ident = val.nameFunction;
            if (args.Count == 1)
            {
                testArgs(ident, "S", args);
                if (currInfoPlayer == null)
                    throw new GLScript.GLApp.GLScriptException("You can't use " + ident + " in this context, not a player event");
                string text = args[0].ToString();
                if (text == "[[TranslateEngine]]")
                    text = lfsLang.replaceParmsLangStr(currInfoPlayer.idLang);

                SendMsgToConnection(currInfoPlayer.UCID, text);
            }
            else if (args.Count == 2)
            {
                testArgs(ident, "SS", args);
				infoPlayer sendToPlayer;
                sendToPlayer = listOfPlayers.getPlayerByUserName((string)args[0]);
                if (sendToPlayer == null)
					SendMsgToConnection(currInfoPlayer.UCID, "^6Unable to send private message. Unknown player: " + (string)args[0]);
			    else{
					string text = args[1].ToString();
                    if (text == "[[TranslateEngine]]")
                        text = lfsLang.replaceParmsLangStr(currInfoPlayer.idLang);
                    SendMsgToConnection(sendToPlayer.UCID, text);
				}
            }
		}
		public void globalmsg(GLScript.unionVal val, ArrayList args)
		{
			infoPlayer currInfoPlayer;
			string ident = val.nameFunction;
            testArgs(ident, "S", args);
            string text = args[0].ToString();
            string newText = "";
            foreach (DictionaryEntry de in listOfPlayers.playersUCID)
            {
                currInfoPlayer = (infoPlayer)de.Value;
                if (text == "[[TranslateEngine]]")
                    newText = lfsLang.replaceParmsLangStr(currInfoPlayer.idLang);
                else
                    newText = text;
                SendMsgToConnection(currInfoPlayer.UCID, newText);
            }
		}
		public void cleanspb(GLScript.unionVal val, ArrayList args)
		{
			infoPlayer currInfoPlayer = newCfg.getCurrInfoPlayer();
			string ident = val.nameFunction;
            if (currInfoPlayer == null)
                throw new GLScript.GLApp.GLScriptException("You can't use " + ident + " in this context, not a player event");
            currInfoPlayer.splitLast = 0;
            for (int i = 0; i < (int)paramLapper.maxSplit; i++)
                currInfoPlayer.sessBestSplitDiff[i] = 0;
            currInfoPlayer.sessBestSplitDiffLast = 0;
            currInfoPlayer.bestSpeed = (double)0;
            SendMsgToConnection(currInfoPlayer.UCID, currInfoPlayer.nickName + "^8 SPB Cleaned");

		}
		public void showspb(GLScript.unionVal val, ArrayList args)
		{
			infoPlayer currInfoPlayer = newCfg.getCurrInfoPlayer();
			string ident = val.nameFunction;
            if (currInfoPlayer == null)
                throw new GLScript.GLApp.GLScriptException("You can't use " + ident + " in this context, not a player event");
            string spb = "";
            try
            {
                switch (currInfoPlayer.viewSPBSplit)
                {
                    case "W":
                    case "P":
                        spb = "PB ";
                        for (int i = 0; i < (int)paramLapper.maxSplit; i++)
                        {
                            if (currInfoPlayer.gripDriverLapInfo.PBBestSplitDiff[i] != 0)
                                spb = spb + "^7SP" + (i + 1).ToString() + ":^8" + unitConv.LongToHMS(currInfoPlayer.gripDriverLapInfo.PBBestSplitDiff[i]);
                        }
                        if (currInfoPlayer.gripDriverLapInfo.PBBestSplitDiffLast != 0)
                            spb = spb + "^7SPL:^8" + unitConv.LongToHMS(currInfoPlayer.gripDriverLapInfo.PBBestSplitDiffLast);
                        break;
                    case "S":
                        spb = "Sess ";
                        for (int i = 0; i < (int)paramLapper.maxSplit; i++)
                        {
                            if (currInfoPlayer.sessBestSplitDiff[i] != 0)
                                spb = spb + "^7SP" + (i + 1).ToString() + ":^8" + unitConv.LongToHMS(currInfoPlayer.sessBestSplitDiff[i]);
                        }
                        if (currInfoPlayer.sessBestSplitDiffLast != 0)
                            spb = spb + "^7SPL:^8" + unitConv.LongToHMS(currInfoPlayer.sessBestSplitDiffLast);
                        break;
                }
                SendMsgToConnection(currInfoPlayer.UCID, spb);
                SendMsgToConnection(currInfoPlayer.UCID, unitConv.LongToHMS(currInfoPlayer.TPb));
            }
            catch (Exception) { }

		}
		public void showhand(GLScript.unionVal val, ArrayList args)
		{
			infoPlayer currInfoPlayer = newCfg.getCurrInfoPlayer();
			string ident = val.nameFunction;
            if (currInfoPlayer == null)
                throw new GLScript.GLApp.GLScriptException("You can't use " + ident + " in this context, not a player event");
            if (newCfg.varsLapper.RefreshHandicapUsers)
                UpdateHandicapUsers(newCfg.varsLapper.HandicapUsers);
            ShowHand(currInfoPlayer, args[0].ToString());
		}
		public void lapperversion(GLScript.unionVal val, ArrayList args)
		{
			infoPlayer currInfoPlayer = newCfg.getCurrInfoPlayer();
			string ident = val.nameFunction;
            if (currInfoPlayer == null)
                throw new GLScript.GLApp.GLScriptException("You can't use " + ident + " in this context, not a player event");
            Ver(currInfoPlayer.UCID);
		}
		public void stats(GLScript.unionVal val, ArrayList args)
		{
			infoPlayer currInfoPlayer = newCfg.getCurrInfoPlayer();
			string ident = val.nameFunction;
            if (currInfoPlayer == null)
                throw new GLScript.GLApp.GLScriptException("You can't use " + ident + " in this context, not a player event");
            testArgs(ident, "S", args);
            ShowStats(currInfoPlayer.UCID, currInfoPlayer.userName, currInfoPlayer.nickName, args[0].ToString(), false);
		}
		public void dstats(GLScript.unionVal val, ArrayList args)
		{
			infoPlayer currInfoPlayer = newCfg.getCurrInfoPlayer();
			string ident = val.nameFunction;
            if (currInfoPlayer == null)
                throw new GLScript.GLApp.GLScriptException("You can't use " + ident + " in this context, not a player event");
            testArgs(ident, "S", args);
            ShowDriftStats(currInfoPlayer.UCID, currInfoPlayer.userName, currInfoPlayer.nickName, args[0].ToString(), false);
		}
		public void statsqual(GLScript.unionVal val, ArrayList args)
		{
			infoPlayer currInfoPlayer = newCfg.getCurrInfoPlayer();
			string ident = val.nameFunction;
            if (currInfoPlayer == null)
                throw new GLScript.GLApp.GLScriptException("You can't use " + ident + " in this context, not a player event");
            testArgs(ident, "S", args);
            ShowStats(currInfoPlayer.UCID, currInfoPlayer.userName, currInfoPlayer.nickName, args[0].ToString(), true);
		}
		public void dstatsqual(GLScript.unionVal val, ArrayList args)
		{
			infoPlayer currInfoPlayer = newCfg.getCurrInfoPlayer();
			string ident = val.nameFunction;
            if (currInfoPlayer == null)
                throw new GLScript.GLApp.GLScriptException("You can't use " + ident + " in this context, not a player event");
            testArgs(ident, "S", args);
            ShowDriftStats(currInfoPlayer.UCID, currInfoPlayer.userName, currInfoPlayer.nickName, args[0].ToString(), true);
		}

		public void currentplayerlfsworldpb(GLScript.unionVal val, ArrayList args)
		{
			infoPlayer currInfoPlayer = newCfg.getCurrInfoPlayer();
			string ident = val.nameFunction;
            if (currInfoPlayer == null)
                throw new GLScript.GLApp.GLScriptException("You can't use " + ident + " in this context, not a player event");
            testArgs(ident, "S", args);
            lfsWorldPB(currInfoPlayer.UCID, currInfoPlayer.userName, currInfoPlayer.nickName, args[0].ToString(), 0);
		}
		public void currentplayerlfsworldpbfrom(GLScript.unionVal val, ArrayList args)
		{
			infoPlayer currInfoPlayer = newCfg.getCurrInfoPlayer();
			string ident = val.nameFunction;
            if (currInfoPlayer == null)
                throw new GLScript.GLApp.GLScriptException("You can't use " + ident + " in this context, not a player event");
            testArgs(ident, "SI", args);
            lfsWorldPB(currInfoPlayer.UCID, currInfoPlayer.userName, currInfoPlayer.nickName, args[0].ToString(), int.Parse(args[1].ToString()));
		}
		public void getlisttop(GLScript.unionVal val, ArrayList args)
		{
			infoPlayer currInfoPlayer = newCfg.getCurrInfoPlayer();
			string ident = val.nameFunction;
			bool flagQual = false;
			bool flagNear = false;
			if (currInfoPlayer == null)
				throw new GLScript.GLApp.GLScriptException("You can't use " + ident + " in this context, not a player event");
			testArgs(ident, "SII", args);
			if (int.Parse((string)args[1]) == 1)
				flagQual = true;
			if (int.Parse((string)args[2]) == 1)
				flagNear = true;
			ArrayList list = GetListTopGrip(currInfoPlayer.userName, args[0].ToString(), flagQual, flagNear);

			val.typVal = GLScript.typVal.setOfVar;
			val.setVars = new GLScript.SetOfVars();
			for (int i = 0; i < list.Count; i++)
			{
				LFSDbs.gripDbs.DriverLapEntry elem = (LFSDbs.gripDbs.DriverLapEntry)list[i];
				val.setVars.Set(i.ToString()+"," + utils.quote("UserName"), new GLScript.unionVal(0, utils.quote(elem.userName), GLScript.typVal.str));
				val.setVars.Set(i.ToString() + "," + utils.quote("NickName"), new GLScript.unionVal(0, utils.quote(elem.nickName), GLScript.typVal.str));
				val.setVars.Set(i.ToString() + "," + utils.quote("CName"), new GLScript.unionVal(0, utils.quote(elem.carName), GLScript.typVal.str));
				val.setVars.Set(i.ToString() + "," + utils.quote("DatePb"), new GLScript.unionVal(0, utils.quote(elem.datePb), GLScript.typVal.str));
				string sgroup = "";
                if (elem.group != -1)
                {
					sgroup = ((char)(elem.group + 65)).ToString();
                }
				val.setVars.Set(i.ToString() + "," + utils.quote("Group"), new GLScript.unionVal(0, utils.quote(sgroup), GLScript.typVal.str));
				val.setVars.Set(i.ToString() + "," + utils.quote("Laps"), new GLScript.unionVal(elem.laps, utils.quote(""), GLScript.typVal.num));
				for( int j = 0; j < elem.PBBestSplitDiff.Length;j++ )
					val.setVars.Set(i.ToString() + "," + utils.quote("PbBestSplitDiff" + j.ToString()), new GLScript.unionVal(elem.PBBestSplitDiff[j], utils.quote(""), GLScript.typVal.num));
				val.setVars.Set(i.ToString() + "," + utils.quote("PbBestSplitDiffLast"), new GLScript.unionVal(elem.PBBestSplitDiffLast, utils.quote(""), GLScript.typVal.num));
				val.setVars.Set(i.ToString() + "," + utils.quote("PbLapTime"), new GLScript.unionVal(elem.personalBestLapTime, utils.quote(""), GLScript.typVal.num));
				val.setVars.Set(i.ToString() + "," + utils.quote("Pos"), new GLScript.unionVal(elem.pos, utils.quote(""), GLScript.typVal.num));
				for( int j = 0; j < elem.splitTime.Length;j++ )
					val.setVars.Set(i.ToString() + "," + utils.quote("SplitTime" + j.ToString()), new GLScript.unionVal(elem.splitTime[j], utils.quote(""), GLScript.typVal.num));
				val.setVars.Set(i.ToString() + "," + utils.quote("TimePb"), new GLScript.unionVal(0, utils.quote(elem.timePb), GLScript.typVal.str));
				val.setVars.Set(i.ToString() + "," + utils.quote("Total"), new GLScript.unionVal(elem.total, utils.quote(""), GLScript.typVal.num));
				string ListPb = "";
				string sep = "";
				for (int j = 0; j < elem.listPB.Count; j++)
				{
					ListPb += sep + (elem.listPB[j] as LFSDbs.gripDbs.PbLapEntry).personalBestLapTime;
					sep = ",";
				}
				val.setVars.Set(i.ToString() + "," + utils.quote("ListPb"), new GLScript.unionVal(0, utils.quote(ListPb), GLScript.typVal.str));

			}

		}
        public void getlisttopdrift(GLScript.unionVal val, ArrayList args)
        {
            infoPlayer currInfoPlayer = newCfg.getCurrInfoPlayer();
            string ident = val.nameFunction;
            bool flagQual = false;
            bool flagNear = false;
            if (currInfoPlayer == null)
                throw new GLScript.GLApp.GLScriptException("You can't use " + ident + " in this context, not a player event");
            testArgs(ident, "SII", args);
            //Get Qualify flags
            if (int.Parse((string)args[1]) == 1)
                flagQual = true;
            if (int.Parse((string)args[2]) == 1)
                flagNear = true;

            ArrayList list = GetListTopDrift(currInfoPlayer.userName, args[0].ToString(), flagQual, flagNear);

            val.typVal = GLScript.typVal.setOfVar;
            val.setVars = new GLScript.SetOfVars();
            for (int i = 0; i < list.Count; i++)
            {
                LFSDbs.driftDbs.DriverLapEntry elem = (LFSDbs.driftDbs.DriverLapEntry)list[i];
                val.setVars.Set(i.ToString() + "," + utils.quote("UserName"), new GLScript.unionVal(0, utils.quote(elem.userName), GLScript.typVal.str));
                val.setVars.Set(i.ToString() + "," + utils.quote("NickName"), new GLScript.unionVal(0, utils.quote(elem.nickName), GLScript.typVal.str));
                val.setVars.Set(i.ToString() + "," + utils.quote("CName"), new GLScript.unionVal(0, utils.quote(elem.carName), GLScript.typVal.str));
                val.setVars.Set(i.ToString() + "," + utils.quote("DatePb"), new GLScript.unionVal(0, utils.quote(elem.datePb), GLScript.typVal.str));
                string sgroup = "";
                if (elem.group != -1)
                {
                    sgroup = ((char)(elem.group + 65)).ToString();
                }
                val.setVars.Set(i.ToString() + "," + utils.quote("DriftPoints"), new GLScript.unionVal(elem.driftPoints, utils.quote(""), GLScript.typVal.num));
                val.setVars.Set(i.ToString() + "," + utils.quote("Group"), new GLScript.unionVal(0, utils.quote(sgroup), GLScript.typVal.str));
                val.setVars.Set(i.ToString() + "," + utils.quote("Pos"), new GLScript.unionVal(elem.pos, utils.quote(""), GLScript.typVal.num));
            }
        }

        public void getlisttopuser(GLScript.unionVal val, ArrayList args)
        {
            infoPlayer currInfoPlayer = newCfg.getCurrInfoPlayer();
            string ident = val.nameFunction;
            bool flagNear = false;
            bool flagDesc = false;

            if (currInfoPlayer == null)
                throw new GLScript.GLApp.GLScriptException("You can't use " + ident + " in this context, not a player event");
            testArgs(ident, "SSSS", args);

            string key = args[0].ToString();
            flagDesc = false;

            if (args[1].ToString().ToLower() == "desc")
                flagDesc = true;
            if (int.Parse((string)args[2]) == 1)
                flagNear = true;

            ArrayList list = GetListTopUser(key,currInfoPlayer.userName, args[3].ToString(), flagNear, flagDesc);

            val.typVal = GLScript.typVal.setOfVar;
            val.setVars = new GLScript.SetOfVars();

            for (int i = 0; i < list.Count; i++)
            {
                LFSDbs.storedDbs.DriverLapEntry elem = (LFSDbs.storedDbs.DriverLapEntry)list[i];
                val.setVars.Set(i.ToString() + "," + utils.quote("UserName"), new GLScript.unionVal(0, utils.quote(elem.userName), GLScript.typVal.str));
                val.setVars.Set(i.ToString() + "," + utils.quote("NickName"), new GLScript.unionVal(0, utils.quote(elem.nickName), GLScript.typVal.str));
                val.setVars.Set(i.ToString() + "," + utils.quote("Value"), new GLScript.unionVal(elem.sumNumVal, utils.quote(""), GLScript.typVal.num));
                val.setVars.Set(i.ToString() + "," + utils.quote("Pos"), new GLScript.unionVal(elem.pos, utils.quote(""), GLScript.typVal.num));
            }
        }

        public void privrcm(GLScript.unionVal val, ArrayList args)
		{
			infoPlayer currInfoPlayer = newCfg.getCurrInfoPlayer();
			string ident = val.nameFunction;
            if (currInfoPlayer == null)
                throw new GLScript.GLApp.GLScriptException("You can't use " + ident + " in this context, not a player event");
            testArgs(ident, "S", args);
            string text = args[0].ToString();
            if (text == "[[TranslateEngine]]")
                text = lfsLang.replaceParmsLangStr(currInfoPlayer.idLang);
            SendMsg("/rcm " + text);
            SendMsg("/rcm_ply " + currInfoPlayer.nickName);
		}
		public void textprivbutton(GLScript.unionVal val, ArrayList args)
		{
			infoPlayer currInfoPlayer = newCfg.getCurrInfoPlayer();
			string ident = val.nameFunction;
            if (currInfoPlayer == null)
                throw new GLScript.GLApp.GLScriptException("You can't use " + ident + " in this context, not a player event");
            if (args.Count == 9)
                args.Add("");
            testArgs(ident, "SS", args);
            string text = args[1].ToString();
            if (text == "[[TranslateEngine]]")
                text = lfsLang.replaceParmsLangStr(currInfoPlayer.idLang);

            currInfoPlayer.playerBox.update(
                                                args[0].ToString(), // ID du boutton
                                                currInfoPlayer.UCID,
                                                text  // Button Text
            );
            currInfoPlayer.playerBox.show(args[0].ToString(), currInfoPlayer.UCID);
		}
		public void textprivbuttonall(GLScript.unionVal val, ArrayList args)
		{
			infoPlayer currInfoPlayer = newCfg.getCurrInfoPlayer();
			string ident = val.nameFunction;
            testArgs(ident, "SS", args);

            string text = args[1].ToString();
            string newText = "";

            foreach (DictionaryEntry de in listOfPlayers.playersUCID)
            {
                infoPlayer CI = (infoPlayer)de.Value;
                newText = text;
                if (newText == "[[TranslateEngine]]")
                    newText = lfsLang.replaceParmsLangStr(currInfoPlayer.idLang);
                else
                CI.playerBox.update(
                        args[0].ToString(), // ID du boutton
                        CI.UCID,
                        newText);  // Button Text
				CI.playerBox.show(args[0].ToString(), CI.UCID);
            }
		}
		public void openprivtextbutton(GLScript.unionVal val, ArrayList args)
		{
			infoPlayer currInfoPlayer = newCfg.getCurrInfoPlayer();
			string ident = val.nameFunction;
            if (currInfoPlayer == null)
                throw new GLScript.GLApp.GLScriptException("You can't use " + ident + " in this context, not a player event");
            testArgs(ident, "SIIIIIISSIS", args);
            string text = args[8].ToString();
            if (text == "[[TranslateEngine]]")
                text = lfsLang.replaceParmsLangStr(currInfoPlayer.idLang);

            currInfoPlayer.playerBox.create(args[0].ToString(), // ID du boutton
                                                currInfoPlayer.UCID,
                                                int.Parse(args[1].ToString()),  // X
                                                int.Parse(args[2].ToString()),  // Y
                                                int.Parse(args[3].ToString()),  // Largeur
                                                int.Parse(args[4].ToString()),  // Hauteur
                                                int.Parse(args[5].ToString()),  // Interligne
                                                -1,                              // Sec Visible
                                                int.Parse(args[9].ToString()),  // TypeIn
                                                int.Parse(args[6].ToString()),  // Bstyle
                                                args[7].ToString(),             // Caption
                                                text,            // Button Text
                                                args[10].ToString()             // BackCall
            );
            currInfoPlayer.playerBox.show(args[0].ToString(), currInfoPlayer.UCID);
		}
		public void myconfig(GLScript.unionVal val, ArrayList args)
		{
			infoPlayer currInfoPlayer = newCfg.getCurrInfoPlayer();
			string ident = val.nameFunction;
            if (currInfoPlayer == null)
                throw new GLScript.GLApp.GLScriptException("You can't use " + ident + " in this context, not a player event");
            showConfigPlayer(currInfoPlayer);
		}
		public void setuserstoredvalue(GLScript.unionVal val, ArrayList args)
		{
			infoPlayer currInfoPlayer = newCfg.getCurrInfoPlayer();
			string ident = val.nameFunction;
            if (args.Count > 2)
            {
                testArgs(ident, "SSS", args);
                infoPlayer storedInfoPlayer;
                storedInfoPlayer = listOfPlayers.getPlayerByUserName((string)args[0]);
                if (storedInfoPlayer != null)
                    storedSqlDbs.updateRowUser( args[1].ToString(), storedInfoPlayer.userName, storedInfoPlayer.nickName, args[2].ToString() );
            }
            else
            {
				if (currInfoPlayer == null)
					throw new GLScript.GLApp.GLScriptException("You can't use " + ident + " in this context, not a player event");
				testArgs(ident, "SS", args);
                storedSqlDbs.updateRowUser( args[0].ToString(), currInfoPlayer.userName,currInfoPlayer.nickName, args[1].ToString() );
            }
		}
		public void getuserstorednum(GLScript.unionVal val, ArrayList args)
		{
			infoPlayer currInfoPlayer = newCfg.getCurrInfoPlayer();
			string ident = val.nameFunction;
			string tempStr;
			if (args.Count > 1)
			{
				testArgs(ident, "SS", args);
				tempStr = storedSqlDbs.retreiveRowUser(args[1].ToString(), args[0].ToString() );
			}
			else
			{
				if (currInfoPlayer == null)
					throw new GLScript.GLApp.GLScriptException("You can't use " + ident + " in this context, not a player event");
				testArgs(ident, "S", args);
				tempStr = storedSqlDbs.retreiveRowUser( args[0].ToString(),currInfoPlayer.userName);
			}
			val.typVal = GLScript.typVal.num;
			try
			{
				val.fval = float.Parse(tempStr);
			}
			catch
			{
				val.fval = -1;
			}
			return;

		}
		public void getuserstoredvalue(GLScript.unionVal val, ArrayList args)
		{
			infoPlayer currInfoPlayer = newCfg.getCurrInfoPlayer();
			string ident = val.nameFunction;
            val.typVal = GLScript.typVal.str;
            if (args.Count > 1)
            {
                testArgs(ident, "SS", args);
                val.sval = utils.quote(storedSqlDbs.retreiveRowUser(args[1].ToString(), args[0].ToString() ));
            }
            else
            {
				if (currInfoPlayer == null)
					throw new GLScript.GLApp.GLScriptException("You can't use " + ident + " in this context, not a player event");
				testArgs(ident, "S", args);
                val.sval = utils.quote(storedSqlDbs.retreiveRowUser(args[0].ToString(), currInfoPlayer.userName ));
            } 
		}
		public void openglobalbutton(GLScript.unionVal val, ArrayList args)
		{
			infoPlayer currInfoPlayer = newCfg.getCurrInfoPlayer();
			string ident = val.nameFunction;
            if (args.Count == 9)
                args.Add("");
            testArgs(ident, "SIIIIIIISS", args);
            listOfPlayers.globalButtonMessage(args[0].ToString(),
                                                int.Parse(args[1].ToString()),
                                                int.Parse(args[2].ToString()),
                                                int.Parse(args[3].ToString()),
                                                int.Parse(args[4].ToString()),
                                                int.Parse(args[5].ToString()),
                                                int.Parse(args[6].ToString()),
                                                0,
                                                int.Parse(args[7].ToString()),
                                                "",
                                                args[8].ToString(),
                                                args[9].ToString()
            );
		}
		public void globalrcm(GLScript.unionVal val, ArrayList args)
		{
			infoPlayer currInfoPlayer = newCfg.getCurrInfoPlayer();
			string ident = val.nameFunction;
            testArgs(ident, "S", args);

            string newText = "";
            string text = args[0].ToString();
            foreach (DictionaryEntry de in listOfPlayers.playersUCID)
            {
                currInfoPlayer = (infoPlayer)de.Value;
                if (text == "[[TranslateEngine]]")
                    newText = lfsLang.replaceParmsLangStr(currInfoPlayer.idLang);
                else
                    newText = text;
                SendMsg("/rcm " + newText);
                SendMsg("/rcm_ply " + currInfoPlayer.nickName);
            }
		}
		public void closeglobalbutton(GLScript.unionVal val, ArrayList args)
		{
			infoPlayer currInfoPlayer = newCfg.getCurrInfoPlayer();
			string ident = val.nameFunction;
            testArgs(ident, "S", args);
            listOfPlayers.globalButtonClose( args[0].ToString() );
		}
		public void http(GLScript.unionVal val, ArrayList args)
		{
			infoPlayer currInfoPlayer = newCfg.getCurrInfoPlayer();
			string ident = val.nameFunction;
            if (currInfoPlayer == null)
                throw new GLScript.GLApp.GLScriptException("You can't use " + ident + " in this context, not a player event");
            testArgs(ident, "S", args);
            objWebCmd.sendWebCmd( currInfoPlayer.UCID, args[0].ToString() );
		}
		public void moveusertogroup(GLScript.unionVal val, ArrayList args)
		{
			infoPlayer currInfoPlayer = newCfg.getCurrInfoPlayer();
			string ident = val.nameFunction;
            testArgs(ident, "SS", args);
            uGroup.addUser(args[0].ToString(), args[1].ToString());
		}
        public void getlistofusersgroup(GLScript.unionVal val, ArrayList args)
        {
            infoPlayer currInfoPlayer = newCfg.getCurrInfoPlayer();
            string ident = val.nameFunction;
            testArgs(ident, "S", args);
            val.clear();
            val.typVal = GLScript.typVal.str;
            val.typArray = true;
            string[] arRet = uGroup.listOfUsersGroup(args[0].ToString());
            for (int i = 0; i < arRet.Length; i++)
                val.add(utils.quote(arRet[i]));
            val.strSort();
            val.add(utils.quote(""));
        }
        public void getlistofplayerbuttons(GLScript.unionVal val, ArrayList args)
        {
            infoPlayer currInfoPlayer = newCfg.getCurrInfoPlayer();
            string ident = val.nameFunction;

            testArgs(ident, "S", args);
            val.clear();
            val.typVal = GLScript.typVal.str;
            val.typArray = true;
            string userName = args[0].ToString();
            currInfoPlayer = listOfPlayers.getPlayerByUserName(userName);
            if (currInfoPlayer == null)
			{
				throw new GLScript.GLApp.GLScriptException("Player name " + (string)args[0] + " in function " + ident + " is not a player");
			}
            string[] lob = currInfoPlayer.playerBox.listOfbutton( );
            if( lob.Length == 0 )
                val.add(utils.quote(""));
            for (int i = 0; i < lob.Length; i++)
                val.add(utils.quote(lob[i]));
            val.strSort();
        }
        public void usergroupfromfile(GLScript.unionVal val, ArrayList args)
		{
			infoPlayer currInfoPlayer = newCfg.getCurrInfoPlayer();
			string ident = val.nameFunction;
            testArgs(ident, "SS", args);
            uGroup.clear(args[0].ToString());
            uGroup.addUserFromFile(args[0].ToString(), newCfg.varsLapper.WorkingDir + "/" + args[1].ToString());
		}
		public void usergrouptofile(GLScript.unionVal val, ArrayList args)
		{
			infoPlayer currInfoPlayer = newCfg.getCurrInfoPlayer();
			string ident = val.nameFunction;
            testArgs(ident, "SS", args);
            uGroup.addUserToFile(args[0].ToString(), newCfg.varsLapper.WorkingDir + "/" + args[1].ToString());
		}
		public void removeuserfromgroup(GLScript.unionVal val, ArrayList args)
		{
			infoPlayer currInfoPlayer = newCfg.getCurrInfoPlayer();
			string ident = val.nameFunction;
            testArgs(ident, "SS", args);
            uGroup.removeUser(args[0].ToString(), args[1].ToString());
		}
		public void cleargroup(GLScript.unionVal val, ArrayList args)
		{
			infoPlayer currInfoPlayer = newCfg.getCurrInfoPlayer();
			string ident = val.nameFunction;
            testArgs(ident, "S", args);
            uGroup.clear(args[0].ToString());
		}
		public void userisserveradmin(GLScript.unionVal val, ArrayList args)
		{
			infoPlayer currInfoPlayer = newCfg.getCurrInfoPlayer();
			string ident = val.nameFunction;
			testArgs(ident, "S", args);
			val.typVal = GLScript.typVal.num;
			if (currInfoPlayer.isServerAdmin == true)
				val.fval = 1;
			else
				val.fval = 0;
		}
		public void userisadmin(GLScript.unionVal val, ArrayList args)
		{
			infoPlayer currInfoPlayer = newCfg.getCurrInfoPlayer();
			string ident = val.nameFunction;
			testArgs(ident, "S", args);
			val.typVal = GLScript.typVal.num;
            uGroup.clear( "admin");
            uGroup.addUserFromFile("admin",newCfg.varsLapper.WorkingDir + "/" + newCfg.varsLapper.AdminFile );
			if (uGroup.userExist("admin", args[0].ToString()) || currInfoPlayer.UCID == 0 || currInfoPlayer.isServerAdmin == true)
				val.fval = 1;
			else
				val.fval = 0;
		}
		public void useringroup(GLScript.unionVal val, ArrayList args)
		{
			infoPlayer currInfoPlayer = newCfg.getCurrInfoPlayer();
			string ident = val.nameFunction;
            testArgs(ident, "SS", args);
            val.typVal = GLScript.typVal.num;
            if (uGroup.userExist(args[0].ToString(), args[1].ToString()))
                val.fval = 1;
            else
                val.fval = 0;
		}
		public void getusergrippb(GLScript.unionVal val, ArrayList args)
		{
			infoPlayer currInfoPlayer = newCfg.getCurrInfoPlayer();
			string ident = val.nameFunction;
            val.typVal = GLScript.typVal.num;
            val.fval = gripSqlDbs.retreivePB(args[0].ToString(), args[0].ToString(), args[1].ToString(), args[2].ToString());
		}
		public void getuserdriftpb(GLScript.unionVal val, ArrayList args)
		{
			infoPlayer currInfoPlayer = newCfg.getCurrInfoPlayer();
			string ident = val.nameFunction;
            val.typVal = GLScript.typVal.num;
            val.fval = (float)driftSqlDbs.retreiveDriftPoint(args[0].ToString(), args[0].ToString(), args[1].ToString(), args[2].ToString());
		}
		public void setstoredvalue(GLScript.unionVal val, ArrayList args)
		{
			infoPlayer currInfoPlayer = newCfg.getCurrInfoPlayer();
			string ident = val.nameFunction;
            testArgs(ident, "SS", args);
            storedSqlDbs.updateRow(args[0].ToString(), args[1].ToString());
		}
		public void getstoredvalue(GLScript.unionVal val, ArrayList args)
		{
			infoPlayer currInfoPlayer = newCfg.getCurrInfoPlayer();
			string ident = val.nameFunction;
			testArgs(ident, "S", args);
			val.typVal = GLScript.typVal.str;
			val.sval = utils.quote(storedSqlDbs.retreiveRow(args[0].ToString()));
		}
		public void getstorednum(GLScript.unionVal val, ArrayList args)
		{
			infoPlayer currInfoPlayer = newCfg.getCurrInfoPlayer();
			string ident = val.nameFunction;
			testArgs(ident, "S", args);
			string tempStr;
			tempStr = storedSqlDbs.retreiveRow(args[0].ToString());
			val.typVal = GLScript.typVal.num;
			try
            {
				val.fval = float.Parse(tempStr);
			}
			catch
			{
				val.fval = -1;
			}
			return;
		}
		public void removeprivdelayedcommand(GLScript.unionVal val, ArrayList args)
		{
            infoPlayer currInfoPlayer = newCfg.getCurrInfoPlayer();
			string ident = val.nameFunction;

            testArgs(ident, "S", args);

            //Get to get info from Player 
            try
            {
                if (currInfoPlayer == null)
                    throw new GLScript.GLApp.GLScriptException("You can't use " + ident + " in this context, not a player event");

                if (currInfoPlayer.userName != "")
                {
                    string idTask = "delayed_" + (string)args[0];
                    for (int i = currInfoPlayer.tasks.Count - 1; i >= 0; i--)
                    {
                        //Remove task from current player
                        if ((currInfoPlayer.tasks[i] as Task).idTask == idTask)
                        {
                            currInfoPlayer.tasks.RemoveAt(i);
                        }
                    }
                }
                else
                {
                    throw new GLScript.GLApp.GLScriptException("Function " + ident + " abort: Player does not exist");
                }
            }
            catch
            {
                
            }
        }
		public void privdelayedcommand(GLScript.unionVal val, ArrayList args)
		{
			infoPlayer currInfoPlayer = newCfg.getCurrInfoPlayer();
			string ident = val.nameFunction;
			string idTask = "";
			if (args.Count == 3)
			{
				testArgs(ident, "SIS", args);
				idTask = args[0].ToString();
				args.RemoveAt(0);
			}
			if (currInfoPlayer == null)
				throw new GLScript.GLApp.GLScriptException("You can't use " + ident + " in this context, not a player event");
			testArgs(ident, "IS", args);
			currInfoPlayer.tasks.Add(new Task("delayed_" + idTask, args[1].ToString(), System.DateTime.Now + new System.TimeSpan(0, 0, int.Parse(args[0].ToString()))));
		}
		public void removehostdelayedcommand(GLScript.unionVal val, ArrayList args)
		{
			infoPlayer currInfoPlayer = listOfPlayers.getPlayerByUCID(0);
			string ident = val.nameFunction;
			testArgs(ident, "S", args);
            try
            {
                if (currInfoPlayer == null)
                    throw new GLScript.GLApp.GLScriptException("You can't use " + ident + " in this context, no valid host found");

                string idTask = "delayed_" + (string)args[0];
                for (int i = currInfoPlayer.tasks.Count - 1; i >= 0; i--)
                {
                    if ((currInfoPlayer.tasks[i] as Task).idTask == idTask)
                        currInfoPlayer.tasks.RemoveAt(i);
                }
            }
            catch
            {

            }
		}
		public void hostdelayedcommand(GLScript.unionVal val, ArrayList args)
		{
			infoPlayer currInfoPlayer = listOfPlayers.getPlayerByUCID(0);
			string ident = val.nameFunction;
			string idTask = "";
			if (args.Count == 3)
			{
				testArgs(ident, "SIS", args);
				idTask = args[0].ToString();
				args.RemoveAt(0);
			}
			if (currInfoPlayer == null)
				throw new GLScript.GLApp.GLScriptException("You can't use " + ident + " in this context, no valid host found");
			testArgs(ident, "IS", args);
			currInfoPlayer.tasks.Add(new Task("delayed_" + idTask, args[1].ToString(), System.DateTime.Now + new System.TimeSpan(0, 0, int.Parse(args[0].ToString()))));
		}
		public void removedelayedcommand(GLScript.unionVal val, ArrayList args)
		{
			string ident = val.nameFunction;
			testArgs(ident, "S", args);
			string idTask = "delayed_" + (string)args[0];
			for (int i = Tasks.Count - 1; i >= 0; i--)
			{
				if ((Tasks[i] as Task).idTask == idTask)
					Tasks.RemoveAt(i);
			}
		}
		public void delayedcommand(GLScript.unionVal val, ArrayList args)
		{
			infoPlayer currInfoPlayer = newCfg.getCurrInfoPlayer();
			string ident = val.nameFunction;
			string idTask = "";
			if (args.Count == 3)
			{
				testArgs(ident, "SIS", args);
				idTask = args[0].ToString();
				args.RemoveAt(0);
			}
            testArgs(ident, "IS", args);
            Tasks.Add(new Task("delayed_" + idTask,args[1].ToString(), System.DateTime.Now + new System.TimeSpan(0, 0, int.Parse( args[0].ToString()) )));
		}
		public void getlongtrackname(GLScript.unionVal val, ArrayList args)
		{
			infoPlayer currInfoPlayer = newCfg.getCurrInfoPlayer();
			string ident = val.nameFunction;
            testArgs(ident, "S", args);
            val.typVal = GLScript.typVal.str;
            val.sval = utils.quote(UTILS.utils.getLongTrackName(args[0].ToString()));
		}
		public void getlengthtrack(GLScript.unionVal val, ArrayList args)
		{
			infoPlayer currInfoPlayer = newCfg.getCurrInfoPlayer();
			string ident = val.nameFunction;
            testArgs(ident, "S", args);
            val.typVal = GLScript.typVal.num;
            if (args.Count > 0)
            {
				testArgs(ident, "S", args);
				val.fval = utils.getLenTrack(args[0].ToString());
            }
            else
            {
				val.fval = utils.getLenTrack(currState.ShortTrackName);
            }
		}
		public void getgrouptrack(GLScript.unionVal val, ArrayList args)
		{
			infoPlayer currInfoPlayer = newCfg.getCurrInfoPlayer();
			string ident = val.nameFunction;
            testArgs(ident, "S", args);
            val.typVal = GLScript.typVal.str;
            val.sval = utils.quote(UTILS.utils.getGroupTrack(args[0].ToString()));
		}
		public void getexttrack(GLScript.unionVal val, ArrayList args)
		{
			infoPlayer currInfoPlayer = newCfg.getCurrInfoPlayer();
			string ident = val.nameFunction;
            testArgs(ident, "S", args);
            val.typVal = GLScript.typVal.str;
            val.sval = utils.quote(UTILS.utils.getExtTrack(args[0].ToString()));
		}
		public void removescheduleaction(GLScript.unionVal val, ArrayList args)
		{
			string ident = val.nameFunction;
			testArgs(ident, "S", args);
			string idTask = (string)args[0];
			for (int i = Tasks.Count-1; i >= 0; i--)
			{
				if ((Tasks[i] as Task).idTask == idTask)
					Tasks.RemoveAt(i);
			}
		}
		public void registerscheduleaction(GLScript.unionVal val, ArrayList args)
		{
			string ident = val.nameFunction;
			string idTask = "";
			string strCmd = "";
			string strCron = "";
            bool execute = true;
			    if (args.Count == 2) 
			    {
				    testArgs(ident, "SS", args);
				    strCron = (string)args[0];
				    strCmd = (string)args[1];
                    if(strCmd == "")
                    {
                        execute = false;
                    }
                }
			    else if (args.Count == 3)
			    {
				    testArgs(ident, "SSS", args);
				    idTask = (string)args[0];
				    strCron = (string)args[1];
				    strCmd = (string)args[2];
                    if ((idTask == "") || (strCmd == ""))
                    {
                        execute = false;
                    }
                }
                if (execute == true)
                {
                    string[] cronTimer = strCron.ToString().Split(':');
                    for (int i = 0; i < cronTimer.Length; i++)
                    {
                        Tasks.Add(new Task(idTask, strCmd, cronTimer[i]));
                    }
                }
                else
                {
                    throw new GLScript.GLApp.GLScriptException("Error on " + ident + " : one or more of the parameter values are incorrect");
                }
		}
		public void removenodeaction(GLScript.unionVal val, ArrayList args)
		{
			infoPlayer currInfoPlayer = newCfg.getCurrInfoPlayer();
			string ident = val.nameFunction;
			testArgs(ident, "SS", args); // ident Task, track
            listOfNodeEvent.Remove( args[0].ToString(), args[1].ToString() );
		}
		public void registernodeaction(GLScript.unionVal val, ArrayList args)
		{
			infoPlayer currInfoPlayer = newCfg.getCurrInfoPlayer();
			string ident = val.nameFunction;
			string idTask = "";
			if (args.Count == 5)
			{
				testArgs(ident, "SSISS", args);
				idTask = args[0].ToString();
				args.RemoveAt(0);
			}
			testArgs(ident, "SISS", args);
			listOfNodeEvent.Add(idTask, args[0].ToString(), int.Parse(args[1].ToString()), args[2].ToString(), args[3].ToString());
		}
		public void registerzoneaction(GLScript.unionVal val, ArrayList args)
		{
			infoPlayer currInfoPlayer = newCfg.getCurrInfoPlayer();
			string ident = val.nameFunction;
            testArgs(ident, "SSIIISS", args);

            //Set variables 
            string idTask = args[0].ToString();
            string shorttrackname = args[1].ToString();
            int X = int.Parse(args[2].ToString());
            int Y = int.Parse(args[3].ToString());
            int dist = int.Parse(args[4].ToString());
            string EnterZone = args[5].ToString();
            string LeaveZone = args[6].ToString();

            testArgs(ident, "SSIIISS", args);
            listOfZoneEvent.Add(idTask, shorttrackname, X, Y, dist, EnterZone, LeaveZone);
		}
		public void removezoneaction(GLScript.unionVal val, ArrayList args)
		{
            infoPlayer currInfoPlayer = newCfg.getCurrInfoPlayer();
             
            string ident = val.nameFunction;
            testArgs(ident, "SS", args); // ident Task, track

            //Set variables
            string idTask = args[0].ToString();
            string shorttrackname = args[1].ToString();

            listOfZoneEvent.Remove(idTask, shorttrackname);
		}
		public void reload(GLScript.unionVal val, ArrayList args)
		{
			infoPlayer currInfoPlayer = newCfg.getCurrInfoPlayer();
			string ident = val.nameFunction;
			this.TermProg = true;
			this.RestartProg = true;
		}
		public void crash(GLScript.unionVal val, ArrayList args)
		{
			infoPlayer currInfoPlayer = null;
			Console.WriteLine(currInfoPlayer.userName);
		}
    }

}